unit f_OrbisDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  f_OrbisForm, StdCtrls, Buttons, ToolWin, ComCtrls, ExtCtrls;

type
  TOrbisDialog_Form = class(TORBISForm)
    Panel1: TPanel;
    b_OK: TBitBtn;
    b_Storno: TBitBtn;
  private
    FModified: boolean;
    procedure SetModified(const Value: boolean);
    { Private declarations }
  public
     procedure WControl_KeyPress(Sender: TObject; var Key: Char);
     function  Move_Kurzor(const aControl: string): boolean;
     property Modified: boolean read FModified write SetModified;
  end;


implementation

{$R *.DFM}

{ TOrbisDialog_Form }

function TOrbisDialog_Form.Move_Kurzor(const aControl: string): boolean;
//var
//   i, fi: integer;
//   CC: TComponent;
//   WC: TWinControl;
//   Next: boolean;
//   S: string;
begin
   result := false;
{
   result := false;
   if combo_cmd.Items.Count = 0 then
      exit;
   if aControl = '' then
   begin
      fi := 0;
   end
   else
   begin
      i := combo_cmd.Items.IndexOf(aControl);
      if i < 0 then exit;
      fi := i + 1;
   end;
   if fi > (combo_cmd.Items.Count - 1) then
      fi := 0;

   S := combo_cmd.Items.Strings[fi];
   Next := false;
   for i := 0 to ComponentCount - 1 do
   begin
      CC := Components[i];
      if Next or SameText(CC.Name, S) then
      begin
         if CC is TWinControl and TWinControl(CC).Visible then
         begin
            WC := TWinControl(CC);
            result := true;
            WC.SetFocus;
            exit;
         end
         else
         begin
            Next := true;
         end;
      end;
   end;
}   
end;

procedure TOrbisDialog_Form.SetModified(const Value: boolean);
begin
  FModified := Value;
end;

procedure TOrbisDialog_Form.WControl_KeyPress(Sender: TObject; var Key: Char);
var
   WC: TWinControl;
begin
   if Key = #13 then
   begin
      if (Sender <> nil) and (Sender is TWinControl) then
      begin
         WC := TWinControl(Sender);
         Move_Kurzor(WC.Name);
      end;
   end;
end;

end.
