unit f_YesNo;

interface

uses WinApi.Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls;

type
  TAnoNeDialog = class(TForm)
    Bevel1: TBevel;
    Memo: TMemo;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
  private
     procedure SetText(aText: string);
  public
     property Text: string write SetText;
  end;

function YesNoDialog(aText: string): boolean;

implementation

{$R *.DFM}

function YesNoDialog(aText: string): boolean;
var
   D: TAnoNeDialog;
begin
   D:= TAnoNeDialog.Create(Application);
   D.Text := aText;
   result := D.ShowModal = mrYes;
   D.Free;
end;


procedure TAnoNeDialog.SetText(aText: string);
begin
   Memo.Lines.Add(aText);
end;

end.
