unit t_GraphicFormControls;

interface
uses
   Controls,
   t_ControlTool;

type
TTestControlTool = class(TControlTool)
  private
    function GetText: string;
    procedure SetText(const Value: string);
protected
   // procedure SetParent(const Value: TControl); override;
public
   procedure CreateControl; override;
published
   property  Text: string read GetText write SetText;
end;

implementation
uses
   Classes,
   ComCtrls,
   ToolWin,
   StdCtrls,
   e_Class;

{ TTestControlTool }

procedure TTestControlTool.CreateControl;
var
   TB: TToolWindow;
   E: TEdit;
   L: TLabel;
begin
   Control := TToolWindow.Create(nil);
   TB := TToolWindow(Control);
   TB.Name := 'TB';
   TB.Width := 245;
   TB.EdgeBorders := [];
   TB.Height := 22;
   E := TEdit.Create(TB);
   E.Name := 'Ey';
   E.Left := 140;
   E.Width := 100;
   E.Height := 8;
   E.Parent := TB;
   L := TLabel.Create(TB);
   L.Name := 'Ly';
   L.Left := 120;
   L.Caption := ' Y: ';
   L.Layout := tlCenter;
   L.Parent := TB;
   E := TEdit.Create(TB);
   E.Name := 'Ex';
   E.Left := 20;
   E.Width := 100;
   E.Height := 15;
   E.Parent := TB;
   L := TLabel.Create(TB);
   L.Name := 'Lx';
   L.Caption := ' X: ';
   L.Layout := tlCenter;
   L.Parent := TB;
end;

function TTestControlTool.GetText: string;
begin
   result := '';
   {
   if Control = nil then exit;
   result := TEdit(Control).Text;
   }
end;
{
procedure TTestControlTool.SetParent(const Value: TControl);
var
   i: integer;
   C: TComponent;
begin
   inherited SetParent(Value);

   if Control = nil then exit;
   for i := 0 to Control.ComponentCount - 1 do
   begin
      C := Control.Components[i];
      if not (C is TControl) then Continue;
      TControl(C).Parent := TWinControl(Control);
   end;
   TToolBar(Control).ButtonHeight := 20;
   TToolBar(Control).AutoSize := true;

end;
}
procedure TTestControlTool.SetText(const Value: string);
begin
   //if Control <> nil then TEdit(Control).Text := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TTestControlTool);
END.
