unit f_Orbis01PDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  f_OrbisDialog, StdCtrls, Buttons, ExtCtrls;

type
  TOrbis01PDialog_form = class(TOrbisDialog_Form)
    rb_XML: TRadioButton;
    rb_Topol: TRadioButton;
    Label1: TLabel;
    l_Path: TLabel;
    ed_Path: TEdit;
    Button1: TButton;
    OpenDialog: TOpenDialog;
    procedure rb_XMLClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Orbis01PDialog_form: TOrbis01PDialog_form;

implementation
uses
   FileCtrl,
   Worlds,
   t_MainTl;

{$R *.DFM}

procedure TOrbis01PDialog_form.rb_XMLClick(Sender: TObject);
begin
   if Sender = rb_XML then
   begin
      rb_XML.Checked := true;
      rb_Topol.Checked := false;
      l_Path.Caption := 'Cesta k souboru XML';
   end
   else
   begin
      rb_XML.Checked := false;
      rb_Topol.Checked := true;
      l_Path.Caption := 'Sloka s bloky Topolu (adr. *.BLK)';
   end;
end;

procedure TOrbis01PDialog_form.Button1Click(Sender: TObject);
var
   S1,S2,S3: string;
begin
  inherited;
  if rb_XML.Checked then
  begin
     if Assigned(TOldMainTool(World.MainTool).On_SelectFile_Event) then
     begin
        if TOldMainTool(World.MainTool).On_SelectFile_Event(OpenDialog.Title,OpenDialog.InitialDir,OpenDIalog.Filter,S1)then
           ed_Path.Text := S1;
        exit;
     end;
     if OpenDialog.Execute then
        ed_Path.Text := OpenDialog.FileName;
  end
  else
  begin
      S1 := 'Vbr sloky s daty TopoLu';
      S2 := '';
      S3 := '';
      if  Assigned(TOldMainTool(World.MainTool).On_SelectDirectory_Event) then
      begin
         if TOldMainTool(World.MainTool).On_SelectDirectory_Event(S1,S2,S3) then
            ed_Path.Text := S3;
         exit;
      end;
      if SelectDirectory(S1,S2,S3) then
         ed_Path.Text := S3;
  end;
end;

end.
