{*******************************************************}
{                                                       }
{       Runtime Licensing Demo Program                  }
{       Use runtime license procedure                   }
{                                                       }
{       Copyright (c) 1998 Help Service Mapping         }
{                                                       }
{*******************************************************}

unit UseLic;

interface

uses Windows, ActiveX;
{
function CreateInprocObjLic(clsid: TCLSID;
                            RunLic: WideString;  // Runtime key
                            riid: TIID;   // Pozadovany interface
                            var pIRet: IUnknown) // Vraceny interface
                            : HRESULT;

}
function CreateInprocObjLic(ProgID: WideString;  // Component ProgID string
                            LicKey: WideString;  // Runtime license key
                            riid: TIID;          // Requested interface
                            var pIntf: IUnknown) // Result
                            : HRESULT;

implementation

uses ComObj;

{
function CreateInprocObjLic(clsid: TCLSID;
                            RunLic: WideString;  // Runtime key
                            riid: TIID;   // Pozadovany interface
                            var pIRet: IUnknown) // Vraceny interface
                            : HRESULT;
var
 hr: HRESULT;
 pClassFactory: IClassFactory2;

label End_end;
begin
  pClassFactory:= NIL;

  hr := CoGetClassObject(clsid, CLSCTX_INPROC_SERVER, NIL,
 IClassFactory2, pClassFactory);

  if(FAILED(hr)) then goto End_end;

  hr := pClassFactory.CreateInstanceLic(NIL, NIL, riid, RunLic, pIRet);

End_end:

  if(pClassFactory <> nil)then pClassFactory:= nil;

  Result:= hr;

end;
}


function CreateInprocObjLic(ProgID: WideString;  // Component ProgID string
                            LicKey: WideString;  // Runtime license key
                            riid: TIID;          // Requested interface
                            var pIntf: IUnknown) // Result
                            : HRESULT;
var
  ClassID: TGUID;
  pClassFactory: IClassFactory2;

begin
  try
    ClassID := ProgIDToClassID(ProgID);

    Result := CoGetClassObject(ClassID, CLSCTX_INPROC_SERVER, nil,
                               IClassFactory2, pClassFactory);

    if not Failed(Result)
    then try
      Result := pClassFactory.CreateInstanceLic(NIL, NIL, riid, LicKey, pIntf);
    finally
      pClassFactory := nil;
    end;
  except
    Result := E_FAIL;
  end;
end;


end.
