unit I_top;

interface
uses
  Graphics,
// KERNEL
  Elements,
// INTERPRET
  i_Basic;

type

TInterpretTopObject = class(TRectInterpret)
private
   //FOwnerProps: TElement;
   FColor: TColor;
   FUseColor: boolean;
   FSymbol: smallInt;
   FUseSymbol: boolean;
   FFillBackGround: boolean;
public
   function  ScaleOK(Element: TElement): boolean;
   //function  GetOwnerBooleanProp(aName: string): boolean;
   //function  GetOwnerLongIntProp(aName: string): longInt;
   //property  OwnerProps: TElement read FOwnerProps write FOwnerProps;
published
   property   Color: TColor read FColor write FColor;
   property   UseColor: boolean read FUseColor write FUseColor;
   property   Symbol: smallInt read FSymbol write FSymbol;
   property   UseSymbol: boolean read FUseSymbol write FUseSymbol;
   property   FillBackGround: boolean read FFillBackGround write FFillBackGround ;
end;




implementation

function TInterpretTopObject.ScaleOK(Element: TElement): boolean;
{
var
  TopO: TTopolObjects;
}
begin
  result:= true;
{
  if (Device = nil) or (Device.Projection = nil) then exit;
  try
    if not (Element is TTopolObjects) then exit;
    TopO:= TTopolObjects(Element);
    if TopO.MinScale > 0 then
    begin
      result:= Device.Projection.Scale >= TopO.MinScale;
      if not result then exit
    end;

    if TopO.MaxScale > 0 then
    begin
      result:= Device.Projection.Scale <= TopO.MaxScale;
    end;
  except
  end
}
end;

(*

function TInterpretTopObject.GetOwnerBooleanProp(aName: string): boolean;
begin
  result:= false;
  if OwnerProps = nil then exit;
  result:= OwnerProps.GetPropertyBooleanByName(aName)
end;

function  TInterpretTopObject.GetOwnerLongIntProp(aName: string): longInt;
begin
  result:= 0;
  if OwnerProps = nil then exit;
  result:= OwnerProps.GetPropertyLongIntByName(aName)
end;

*)




end.
