{$N+}
unit TranRast;


{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} interface {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

uses
     BlokType;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

procedure Transformuj(Transformace: pointer; PolLinie: TLomBodPtr);

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} implementation {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

uses {$IFDEF Delphi} Messages, {$ENDIF}
     WinDos, WinTypes, WinProcs, Strings, OWindows,
     MatProc, Header, MyStream, StrProc, FilProc, TranType,
     Zakloinc, ProsGlob,
     RasOpDLL,
     RasGlob, RasMNDll, RastProc,
     ParRas,
     Pokus,
     PomDlg;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}



procedure TransformujRastr(
                           const Soubor   : Pointer;
                                 TransfPtr: pointer;
                                 PolLinie : TLomBodPtr);

var
  fSt: pointer;
  fN: pointer;
  Pom2Str, JmenoNovehoRastru: TPathStr;
  i, j: integer;
  pom: byte;
  Cesta, CestaN: TDirStr;
  Jmeno, JmenoN : TNameStr;
  Ext, ExtN: TExtStr;
  BodZdr, BodCil: TranType.Bod;
  Head: TypHeader;
  Rozmer: TObdelnik;
  SloupcuN, RadkuN: word;
  MinSRadkuN, MinSSloupcuN, MaxSRadkuN, MaxSSloupcuN, CRadkun, CSloupcun: extended;
  MinSRadkuNR, MinSSloupcuNR, MaxSRadkuNR, MaxSSloupcuNR, CRadkunR, CSloupcunR: real;
  EscDone: boolean;
  fRoh: text;
  PomKanal: PPathS;
  Retezec1, Retezec2: array[0..255] of char;
  PomKurzor: HCursor;
  PomPtr: TLomBodPtr;
  fMeze: file;
  M: TMsg;
  PomRohy: TObdelnik;

begin
(*
  FileSplit(Soubor^.Jmeno, Cesta, Jmeno, Ext);
  StrCopy(JmenoNovehoRastru, Cesta);
  StrCat (JmenoNovehoRastru, '.ras');

  TransformaceDejSourRohu(TransfPtr, PomRohy);

  case SourSystem of
    JTSK        : with PomRohy do
                  begin
                    BodZdr.X := PH.Y;
                    BodZdr.Y := PH.X;
                    TransformaceTransformuj(TransfPtr, BodZdr, BodCil);
                    MinSSloupcuN := BodCil.X;
                    MinSRadkuN   := BodCil.Y;
                    MaxSSloupcuN := BodCil.X;
                    MaxSRadkuN   := BodCil.Y;

                    BodZdr.X := LD.Y;
                    BodZdr.Y := LD.X;
                    TransformaceTransformuj(TransfPtr, BodZdr, BodCil);
                    if BodCil.X < MinSSloupcuN then MinSSloupcuN := BodCil.X;
                    if BodCil.Y < MinSRadkuN   then MinSRadkuN   := BodCil.Y;
                    if BodCil.X > MaxSSloupcuN then MaxSSloupcuN := BodCil.X;
                    if BodCil.Y > MaxSRadkuN   then MaxSRadkuN   := BodCil.Y;

                    BodZdr.X := PH.Y;
                    BodZdr.Y := LD.X;
                    TransformaceTransformuj(TransfPtr, BodZdr, BodCil);
                    if BodCil.X < MinSSloupcuN then MinSSloupcuN := BodCil.X;
                    if BodCil.Y < MinSRadkuN   then MinSRadkuN   := BodCil.Y;
                    if BodCil.X > MaxSSloupcuN then MaxSSloupcuN := BodCil.X;
                    if BodCil.Y > MaxSRadkuN   then MaxSRadkuN   := BodCil.Y;

                    BodZdr.X := LD.Y;
                    BodZdr.Y := PH.X;
                    TransformaceTransformuj(TransfPtr, BodZdr, BodCil);
                    if BodCil.X < MinSSloupcuN then MinSSloupcuN := BodCil.X;
                    if BodCil.Y < MinSRadkuN   then MinSRadkuN   := BodCil.Y;
                    if BodCil.X > MaxSSloupcuN then MaxSSloupcuN := BodCil.X;
                    if BodCil.Y > MaxSRadkuN   then MaxSRadkuN   := BodCil.Y;
                  end;

    Matematicky,
    Gauss       : with Soubor^, PomRohy do
                  begin
                    BodZdr.X := IY - PH.Y + 1;
                    BodZdr.Y := IX - PH.X + 1;
                    TransformaceTransformuj(TransfPtr, BodZdr, BodCil);
                    MinSSloupcuN := BodCil.X;
                    MinSRadkuN   := BodCil.Y;
                    MaxSSloupcuN := BodCil.X;
                    MaxSRadkuN   := BodCil.Y;

                    BodZdr.X := IY - LD.Y + 1;
                    BodZdr.Y := IX - LD.X + 1;
                    TransformaceTransformuj(TransfPtr, BodZdr, BodCil);
                    if BodCil.X < MinSSloupcuN then MinSSloupcuN := BodCil.X;
                    if BodCil.Y < MinSRadkuN   then MinSRadkuN   := BodCil.Y;
                    if BodCil.X > MaxSSloupcuN then MaxSSloupcuN := BodCil.X;
                    if BodCil.Y > MaxSRadkuN   then MaxSRadkuN   := BodCil.Y;

                    BodZdr.X := IY - PH.Y + 1;
                    BodZdr.Y := IX - LD.X + 1;
                    TransformaceTransformuj(TransfPtr, BodZdr, BodCil);
                    if BodCil.X < MinSSloupcuN then MinSSloupcuN := BodCil.X;
                    if BodCil.Y < MinSRadkuN   then MinSRadkuN   := BodCil.Y;
                    if BodCil.X > MaxSSloupcuN then MaxSSloupcuN := BodCil.X;
                    if BodCil.Y > MaxSRadkuN   then MaxSRadkuN   := BodCil.Y;

                    BodZdr.X := IY - LD.Y + 1;
                    BodZdr.Y := IX - PH.X + 1;
                    TransformaceTransformuj(TransfPtr, BodZdr, BodCil);
                    if BodCil.X < MinSSloupcuN then MinSSloupcuN := BodCil.X;
                    if BodCil.Y < MinSRadkuN   then MinSRadkuN   := BodCil.Y;
                    if BodCil.X > MaxSSloupcuN then MaxSSloupcuN := BodCil.X;
                    if BodCil.Y > MaxSRadkuN   then MaxSRadkuN   := BodCil.Y;
                  end;
  end;

  with PomRohy do
  begin
    RadkuN   := succ(round(LD.X - PH.X));
    SloupcuN := succ(round(LD.Y - PH.Y));
  end;

  if RadkuN <> 1 then
    CRadkuN := (MaxSRadkuN-MinSRadkuN)/pred(RadkuN)
  else
    CRadkuN := 1;

  if SloupcuN <> 1 then
    CSloupcuN := (MaxSSloupcuN-MinSSloupcuN)/pred(SloupcuN)
  else
    CSloupcun := 1;

  MinSRadkuNR   := MinSRadkuN;
  MinSSloupcuNR := MinSSloupcuN;
  MaxSRadkuNR   := MaxSRadkuN;
  MaxSSloupcuNR := MaxSSloupcuN;
  CRadkunR      := CRadkun;
  CSloupcunR    := CSloupcun;

  New(PomKanal);
  StrCopy(PomKanal^.Jmeno, Soubor^.Jmeno);
  PomKanal^.Dalsi :=  nil;

  if Soubor^.Typ = pakov then
    Pom := 0
  else
    if (Soubor^.Typ = binary4) or (Soubor^.Typ = composit4) then
      Pom := 3
    else
      Pom := 1;


  LoadString(HInstance, 203, Retezec1, 256);
  {'Parametry rastru pro transformaci'}
  case SourSystem of
    JTSK       : EscDone := not VratParametryNovehoRastru(Retezec1, true,
                                                          PomKanal, JmenoNovehoRastru,
                                                          MinSSloupcuNR, MaxSSloupcuNR,
                                                          MinSRadkuNR, MaxSRadkuNR,
                                                          CSloupcuNR, CRadkuNR, SloupcuN, RadkuN, Pom);
    Matematicky: EscDone := not VratParametryNovehoRastru(Retezec1, true,
                                                          PomKanal, JmenoNovehoRastru,
                                                          MinSRadkuNR, MaxSRadkuNR,
                                                          MinSSloupcuNR, MaxSSloupcuNR,
                                                          CRadkuNR, CSloupcuNR, RadkuN, SloupcuN, Pom);
    Gauss      : EscDone := not VratParametryNovehoRastru(Retezec1, true,
                                                          PomKanal, JmenoNovehoRastru,
                                                          MinSSloupcuNR, MaxSSloupcuNR,
                                                          MinSRadkuNR, MaxSRadkuNR,
                                                          CSloupcuNR, CRadkuNR, SloupcuN, RadkuN, Pom);
  end;
  ZrusSeznamSouboru(PomKanal);

  if Soubor^.Typ = pakov then
  begin
    if SloupcuN mod 8 <> 0 then
    begin
      SloupcuN      := (succ(SloupcuN shr 3)) shl 3;
      MaxSRadkuNR   := MinSRadkuNR   + pred(RadkuN  )*CRadkuNR  ;
      MaxSSloupcuNR := MinSSloupcuNR + pred(SloupcuN)*CSloupcuNR;
    end;
  end
  else
    if (Soubor^.Typ = binary4) or (Soubor^.Typ = composit4) then
      if SloupcuN mod 2 <> 0 then
      begin
        SloupcuN      := succ(SloupcuN);
        MaxSRadkuNR   := MinSRadkuNR   + pred(RadkuN  )*CRadkuNR  ;
        MaxSSloupcuNR := MinSSloupcuNR + pred(SloupcuN)*CSloupcuNR;
      end;


  FileSplit(TransformaceDejNazevTransfTabulky(TransfPtr), CestaN, JmenoN, ExtN);
  StrCopy(Pom2Str, CestaN);
  StrCat (Pom2Str, JmenoN);
  StrCat (Pom2Str, '.ROH');
  assign(fRoh, Pom2Str);
{$I-}
  rewrite(fRoh);
  if IOResult <> 0 then ;
  writeLn(fRoh, RadkuN, ' ', SloupcuN);
  if IOResult <> 0 then ;
  writeLn(fRoh, MinSRadkuNR,' ', MinSSloupcuNR,' ', MaxSRadkuNR, ' ', MaxSSloupcuNR);
  if IOResult <> 0 then ;
  writeLn(fRoh, CRadkuNR, ' ', CSloupcuNR);
  if IOResult <> 0 then ;
  close(fRoh);
  if IOResult <> 0 then ;
{$I+}


  if not EscDone then
  begin
    PomKurzor := SetCursor(LoadCursor(0, idc_Wait));

    MinSRadkuN   := MinSRadkuNR;
    MinSSloupcuN := MinSSloupcuNR;
    MaxSRadkuN   := MaxSRadkuNR;
    MaxSSloupcuN := MaxSSloupcuNR;
    CRadkun      := CRadkunR;
    CSloupcun    := CSloupcunR;

    FileSplit(JmenoNovehoRastru, CestaN, JmenoN, ExtN);


    LoadString(HInstance, 621, Retezec1, 256);
    LoadString(HInstance, 622, Retezec2, 256);
    if (StrIComp(TransformaceDejNazevTransformace(TransfPtr), Retezec1{'PODOBN 2D'}) = 0) or
       (StrIComp(TransformaceDejNazevTransformace(TransfPtr), Retezec2{'AFINN  2D'}) = 0) then
      fSt := PPRStreamRasInit(Soubor^.Jmeno, 64000, 10000)
    else
      fSt := PPRStreamRasInit(Soubor^.Jmeno, 64000, 0);

    if MyStreamStatus(fSt) <> 0 then
    begin
      MyStreamDone(fSt);
      while PolLinie <> nil do
      begin
        PomPtr := PolLinie^.Dalsi;
        Dispose(PolLinie);
        PolLinie := PomPtr;
      end;
      SetCursor(PomKurzor);
      exit;
    end;

    with Head do
    begin
      fillChar(Name, 20, ' ');
      Zoom    := 0;
      Verze   := Soubor^.Verse;
      Komprese:= 0;
      Scale   := 0;
      fillChar(Dummy, 436, 0);
    end;


    if (Soubor^.Typ <> pakov) then
    begin
      if (Soubor^.Typ = composit) or (Soubor^.Typ = composit4) then
      begin
        if Soubor^.Typ = composit then
          Head.TypSou := 2
        else
          Head.TypSou := 4;

        Head.Stav   := 1;

        StrCopy(Pom2Str, CestaN);
        StrCat (Pom2Str, JmenoN);
        StrCat (Pom2Str, '.pal');
        with Soubor^ do
        begin
{$I-}
          assign(fMeze, Pom2Str);
          rewrite(fMeze, 1);
          blockWrite(fMeze, PocetBarevRastru, 1);
          if IOResult <> 0 then;
          for i := 0 to pred(PocetBarevRastru) do
          begin
{$R-}
            blockWrite(fMeze, Paleta^[i].C_Barvy, 1);
            if IOResult <> 0 then;

            if Verse = 0 then
              Pom := Paleta^[i].Cervena div 4
            else
              Pom := Paleta^[i].Cervena;
            blockWrite(fMeze, Pom, 1);
            if IOResult <> 0 then;

            if Verse = 0 then
              Pom := Paleta^[i].Zelena div 4
            else
              Pom := Paleta^[i].Zelena;
            blockWrite(fMeze, Pom, 1);
            if IOResult <> 0 then;

            if Verse = 0 then
              Pom := Paleta^[i].Modra div 4
            else
              Pom := Paleta^[i].Modra;
            blockWrite(fMeze, Pom, 1);
            if IOResult <> 0 then;
{$R+}
          end;
          close(fMeze);
{$I+}
        end;
      end else
      begin
        if Soubor^.Typ =binary then
          Head.TypSou := 1
        else
          Head.TypSou := 3;
        Head.Stav   := 1;
      end;

      StrCopy(Pom2Str, CestaN);
      StrCat (Pom2Str, JmenoN);
      StrCat (Pom2Str, '.mez');
      with Soubor^ do
      begin
{$I-}
        assign(fMeze, Pom2Str);
        rewrite(fMeze, 1);
        blockWrite(fMeze, Meze^, 256);
        if IOResult <> 0 then;

        if (Typ = binary4) or (Typ = composit4) then
          seek(fMeze, 0)
        else
          seek(fMeze, 255);

        pom := 0;
        blockWrite(fMeze, pom, 1);
        if IOResult <> 0 then;

        close(fMeze);
        if IOResult <> 0 then;
{$I+}
      end;

      SetCursor(PomKurzor);
      while PeekMessage(M, 0, wm_DispoAbort, wm_DispoAbort, pm_Remove) do
      begin
        TranslateMessage(M);
        DispatchMessage(M);
      end;
      LoadString(HInstance, 546, Retezec1, 255);
      AbortDlg := New(PAbortDlgNM, Init(Application^.MainWindow, Retezec1));
      Application^.MakeWindow(AbortDlg);
      while PeekMessage(M,0,wm_Paint,wm_Paint,pm_Remove) do
      begin
        TranslateMessage(M);
        DispatchMessage(M);
      end;
      UserAbort   := False;
      PAbortDlgNM(AbortDlg)^.ZmenTitle(JmenoNovehoRastru, RadkuN);

      if PolLinie = nil then
        case SourSystem of
          JTSK       : TransformujRastr256J(
{$IFDEF Windows}
                                            DalsiKrokAbortNMCallBack,
                                            BylUserAbortAbortNMCallBack,
                                            KeepWindowsAliveCallBack,
{$ENDIF}
                                            TransfPtr, Soubor^.IY, Soubor^.IX, JmenoNovehoRastru,
                                            fSt, Head, MinSSloupcuN, MinSRadkuN, CSloupcuN, CRadkuN,
                                            SloupcuN, RadkuN, EscDone);
          Matematicky: TransformujRastr256M(
{$IFDEF Windows}
                                            DalsiKrokAbortNMCallBack,
                                            BylUserAbortAbortNMCallBack,
                                            KeepWindowsAliveCallBack,
{$ENDIF}
                                            TransfPtr, Soubor^.IY, Soubor^.IX, JmenoNovehoRastru,
                                            fSt, Head, MinSSloupcuN, MaxSRadkuN, CSloupcuN, CRadkuN,
                                            SloupcuN, RadkuN, EscDone, false);
          Gauss      : TransformujRastr256M(
{$IFDEF Windows}
                                            DalsiKrokAbortNMCallBack,
                                            BylUserAbortAbortNMCallBack,
                                            KeepWindowsAliveCallBack,
{$ENDIF}
                                            TransfPtr, Soubor^.IY, Soubor^.IX, JmenoNovehoRastru,
                                            fSt, Head, MinSSloupcuN, MaxSRadkuN, CSloupcuN, CRadkuN,
                                            SloupcuN, RadkuN, EscDone, true);
        end
      else
      begin
        case SourSystem of
          JTSK       :
		       TransformujRastr256PolJ(
{$IFDEF Windows}
                                               DalsiKrokAbortNMCallBack,
                                               BylUserAbortAbortNMCallBack,
                                               KeepWindowsAliveCallBack,
{$ENDIF}
                                               TransfPtr, Soubor^.IY, Soubor^.IX, JmenoNovehoRastru,
                                               fSt, fN, Head, MinSSloupcuN, MinSRadkuN, CSloupcuN, CRadkuN,
                                               SloupcuN, RadkuN, PolLinie, EscDone);
          Matematicky: TransformujRastr256PolM(
{$IFDEF Windows}
                                               DalsiKrokAbortNMCallBack,
                                               BylUserAbortAbortNMCallBack,
                                               KeepWindowsAliveCallBack,
{$ENDIF}
                                               TransfPtr, Soubor^.IY, Soubor^.IX, JmenoNovehoRastru,
                                               fSt, fN, Head, MaxSSloupcuN, MaxSRadkuN, CSloupcuN, CRadkuN,
                                               SloupcuN, RadkuN, PolLinie, EscDone, false);
          Gauss      : TransformujRastr256PolM(
{$IFDEF Windows}
                                               DalsiKrokAbortNMCallBack,
                                               BylUserAbortAbortNMCallBack,
                                               KeepWindowsAliveCallBack,
{$ENDIF}
                                               TransfPtr, Soubor^.IY, Soubor^.IX, JmenoNovehoRastru,
                                               fSt, fN, Head, MaxSSloupcuN, MaxSRadkuN, CSloupcuN, CRadkuN,
                                               SloupcuN, RadkuN, PolLinie, EscDone, true);
        end;
        while PolLinie <> nil do
        begin
          PomPtr := PolLinie^.Dalsi;
          Dispose(PolLinie);
          PolLinie := PomPtr;
        end;
      end;

      Dispose(AbortDlg, Done);
      SetCursor(LoadCursor(0, idc_Wait));
    end else
    begin
      Head.TypSou := 0;
      Head.Stav   := 1;

      SetCursor(PomKurzor);
      while PeekMessage(M, 0, wm_DispoAbort, wm_DispoAbort, pm_Remove) do
      begin
        TranslateMessage(M);
        DispatchMessage(M);
      end;
      LoadString(HInstance, 546, Retezec1, 255);
      AbortDlg := New(PAbortDlgNM, Init(Application^.MainWindow, Retezec1));
      Application^.MakeWindow(AbortDlg);
      while PeekMessage(M,0,wm_Paint,wm_Paint,pm_Remove) do
      begin
        TranslateMessage(M);
        DispatchMessage(M);
      end;
      UserAbort   := False;
      PAbortDlgNM(AbortDlg)^.ZmenTitle(JmenoNovehoRastru, RadkuN);

      if PolLinie = nil then
        case SourSystem of
          JTSK       : TransformujRastr2J(
{$IFDEF Windows}
                                          DalsiKrokAbortNMCallBack,
                                          BylUserAbortAbortNMCallBack,
                                          KeepWindowsAliveCallBack,
{$ENDIF}
                                          TransfPtr, Soubor^.IY, Soubor^.IX, JmenoNovehoRastru,
                                          fSt, Head, MinSSloupcuN, MinSRadkuN, CSloupcuN, CRadkuN,
                                          SloupcuN, RadkuN, EscDone);
          Matematicky: TransformujRastr2M(
{$IFDEF Windows}
                                          DalsiKrokAbortNMCallBack,
                                          BylUserAbortAbortNMCallBack,
                                          KeepWindowsAliveCallBack,
{$ENDIF}
                                          TransfPtr, Soubor^.IY, Soubor^.IX, JmenoNovehoRastru,
                                          fSt, Head, MinSSloupcuN, MaxSRadkuN, CSloupcuN, CRadkuN,
                                          SloupcuN, RadkuN, EscDone, false);
          Gauss      : TransformujRastr2M(
{$IFDEF Windows}
                                          DalsiKrokAbortNMCallBack,
                                          BylUserAbortAbortNMCallBack,
                                          KeepWindowsAliveCallBack,
{$ENDIF}
                                          TransfPtr, Soubor^.IY, Soubor^.IX, JmenoNovehoRastru,
                                          fSt, Head, MinSSloupcuN, MaxSRadkuN, CSloupcuN, CRadkuN,
                                          SloupcuN, RadkuN, EscDone, true);
        end
      else
      begin
        case SourSystem of
          JTSK       :
               	       TransformujRastr2PolJ(
{$IFDEF Windows}
                                             DalsiKrokAbortNMCallBack,
                                             BylUserAbortAbortNMCallBack,
                                             KeepWindowsAliveCallBack,
{$ENDIF}
                                             TransfPtr, Soubor^.IY, Soubor^.IX, JmenoNovehoRastru,
                                             fSt, fN, Head, MinSSloupcuN, MinSRadkuN, CSloupcuN, CRadkuN,
                                             SloupcuN, RadkuN, PolLinie, EscDone);
          Matematicky: TransformujRastr2PolM(
{$IFDEF Windows}
                                             DalsiKrokAbortNMCallBack,
                                             BylUserAbortAbortNMCallBack,
                                             KeepWindowsAliveCallBack,
{$ENDIF}
                                             TransfPtr, Soubor^.IY, Soubor^.IX, JmenoNovehoRastru,
                                             fSt, fN, Head, MaxSSloupcuN, MaxSRadkuN, CSloupcuN, CRadkuN,
                                             SloupcuN, RadkuN, PolLinie, EscDone, false);
          Gauss      : TransformujRastr2PolM(
{$IFDEF Windows}
                                             DalsiKrokAbortNMCallBack,
                                             BylUserAbortAbortNMCallBack,
                                             KeepWindowsAliveCallBack,
{$ENDIF}
                                             TransfPtr, Soubor^.IY, Soubor^.IX, JmenoNovehoRastru,
                                             fSt, fN, Head, MaxSSloupcuN, MaxSRadkuN, CSloupcuN, CRadkuN,
                                             SloupcuN, RadkuN, PolLinie, EscDone, true);
        end;
        while PolLinie <> nil do
        begin
          PomPtr := PolLinie^.Dalsi;
          Dispose(PolLinie);
          PolLinie := PomPtr;
        end;
      end;

      Dispose(AbortDlg, Done);
      SetCursor(LoadCursor(0, idc_Wait));
    end;

    MyStreamDone(fSt);
    if not EscDone then
    begin
      if not NovyPrvekPouzeDoAktOkna and not DoNovehoOkna then
      begin
        with SpravceRastru^ do
        begin
          NastavPrvniRastr;
          while (SeznamRastru <> nil) and (SeznamRastru <> AktRastr) do
            SeznamRastru := SeznamRastru^.Dalsi;
          if SeznamRastru <> nil then
            VypusteniZeSeznamuRastru;
        end;
        if not JeVPredmetuZajmuNactiNoveAZobraz(JmenoNovehoRastru) then
          if SpravceRastru^.ZarazeniDoSeznamuRastru(JmenoNovehoRastru) then
            SendMessage(Application^.MainWindow^.HWindow, wm_ZobrazVseOkna, 0, 0);
      end
      else
        if NovyPrvekPouzeDoAktOkna then
        begin
          with SpravceRastru^ do
          begin
            NastavPrvniRastr;
            while (SeznamRastru <> nil) and (SeznamRastru <> AktRastr) do
              SeznamRastru := SeznamRastru^.Dalsi;
            if SeznamRastru <> nil then
              VypusteniZeSeznamuRastru;

            if not JeVPredmetuZajmu(JmenoNovehoRastru) then
              ZarazeniDoSeznamuRastru(JmenoNovehoRastru);
            SendMessage(Application^.MainWindow^.HWindow, wm_ZobrazVseOknaSRastremAVypusten, 0, longInt(@JmenoNovehoRastru));
          end;
        end else
        begin
          if not JeVPredmetuZajmu(JmenoNovehoRastru) then
            SpravceRastru^.ZarazeniDoSeznamuRastru(JmenoNovehoRastru)
          else
            SendMessage(Application^.MainWindow^.HWindow, wm_ZobrazVseOknaSRastrem, 0, longInt(@JmenoNovehoRastru));
          SendMessage(Application^.MainWindow^.HWindow, wm_NoveOknoSRastrem, 0, longInt(@JmenoNovehoRastru));
        end;
    end
    else
      ZrusRastr(JmenoNovehoRastru, false, false);

    SetCursor(PomKurzor);
  end
  else
    while PolLinie <> nil do
    begin
      PomPtr := PolLinie^.Dalsi;
      Dispose(PolLinie);
      PolLinie := PomPtr;
    end;
*)
end;









procedure Transformuj(
                      Transformace: pointer;
                      PolLinie    : TLomBodPtr);
begin
  TransformujRastr(SRGetAktRastr, Transformace, PolLinie);
  TransformaceDone(Transformace);
end;

end.
