unit TransBLK;

interface

function NactiMetoduTrBLK(
                          var IdB : word;
                          dlg_Help: word): boolean;

function NactiMetoduTrTabl(
                           var IdB : word;
                           dlg_Help: word): boolean;


procedure UrciTrKlicATransformujBLK(
                                    IdB, Druh: word);

procedure VyberLinieProTr(
                          var Parametr); far;

procedure VypniTransformaciTabletu;

implementation

uses WinTypes, OWindows, ODialogs, WinDos, Strings, WinProcs,
     Hlasky,
     TopolInc, ZakloInc, GlobProm,
     TranMet,
     StrProc, MatProc, PlochPri, TranType,
     RasOpDLL,
     PomDlg,
     Tablet,
     BlokPred, BlokType, BlokObj,
{$IFDEF PoCastech}
     TrVekPC,
{$ENDIF}
     Pokus, Pokus1, VyberPro, VybLinOb,
     IdBody;

function NactiMetoduTrBLK(
                          var IdB : word;
                          dlg_Help: word): boolean;


type
  TMetodaTrData = record
    IdBody: array[0..8] of word;
  end;

var
  Data: TMetodaTrData;
  Dlg: PTranMetDlg;
  RB: PRadioButton;
  i: word;
  Retezec1: array[0..50] of char;

begin
  with Data do
  begin
    IdBody[0] := bf_UnChecked;
    IdBody[1] := bf_UnChecked;
    IdBody[2] := bf_UnChecked;
    IdBody[3] := bf_UnChecked;
    IdBody[4] := bf_UnChecked;
    IdBody[5] := bf_UnChecked;
    IdBody[6] := bf_UnChecked;
    IdBody[7] := bf_Checked;
    IdBody[8] := bf_UnChecked;
  end;

  if dlg_Help = cm_TransformaceLinii then
    LoadString(HInstance, 440, Retezec1, 50)
  else
    if dlg_Help = cm_TransformaceBloku then
      LoadString(HInstance, 439, Retezec1, 50)
    else
      if dlg_Help = cm_TransformaceBlokuPC then
        LoadString(HInstance, 442, Retezec1, 50)
      else
        LoadString(HInstance, 444, Retezec1, 50);

  Dlg := New(PTranMetDlg, Init(Application^.MainWindow, 'TransfVek', Retezec1, dlg_Help));
  New(RB, InitResource(Dlg, id_RB2 ));
  New(RB, InitResource(Dlg, id_RB3 ));
  New(RB, InitResource(Dlg, id_RB4 ));
  New(RB, InitResource(Dlg, id_RB5 ));
  New(RB, InitResource(Dlg, id_RB6 ));
  New(RB, InitResource(Dlg, id_RB7 ));
  New(RB, InitResource(Dlg, id_RB8 ));
  New(RB, InitResource(Dlg, id_RB9 ));
  New(RB, InitResource(Dlg, id_RB10));
  Dlg^.TransferBuffer := @Data;
  if Application^.ExecDialog(Dlg) <> idCancel then
  begin
    NactiMetoduTrBLK := true;
    with Data do
    begin
      i := 0;
      while IdBody[i] <> bf_Checked do
        inc(i);
      IdB := i;
    end;
  end
  else
    NactiMetoduTrBLK := false;
end;


function NactiMetoduTrTabl(
                           var IdB : word;
                           dlg_Help: word): boolean;


type
  TMetodaTrData = record
    IdBody: array[0..9] of word;
  end;

var
  Data: TMetodaTrData;
  Dlg: PTranMetDlg;
  RB: PRadioButton;
  i: word;
  Retezec1: array[0..50] of char;

begin
  with Data do
  begin
    IdBody[0] := bf_UnChecked;
    IdBody[1] := bf_UnChecked;
    IdBody[2] := bf_UnChecked;
    IdBody[3] := bf_UnChecked;
    IdBody[4] := bf_UnChecked;
    IdBody[5] := bf_UnChecked;
    IdBody[6] := bf_UnChecked;
    IdBody[7] := bf_Checked;
    IdBody[8] := bf_UnChecked;
    IdBody[9] := bf_UnChecked;
  end;

  LoadString(HInstance, 444, Retezec1, 50);

  Dlg := New(PTranMetDlg, Init(Application^.MainWindow, 'TransfTabl', Retezec1, dlg_Help));
  New(RB, InitResource(Dlg, id_RB2 ));
  New(RB, InitResource(Dlg, id_RB3 ));
  New(RB, InitResource(Dlg, id_RB4 ));
  New(RB, InitResource(Dlg, id_RB5 ));
  New(RB, InitResource(Dlg, id_RB6 ));
  New(RB, InitResource(Dlg, id_RB7 ));
  New(RB, InitResource(Dlg, id_RB8 ));
  New(RB, InitResource(Dlg, id_RB9 ));
  New(RB, InitResource(Dlg, id_RB99));
  New(RB, InitResource(Dlg, id_RB10));
  Dlg^.TransferBuffer := @Data;
  if Application^.ExecDialog(Dlg) <> idCancel then
  begin
    NactiMetoduTrTabl := true;
    with Data do
    begin
      i := 0;
      while IdBody[i] <> bf_Checked do
        inc(i);
      IdB := i;
    end;
  end
  else
    NactiMetoduTrTabl := false;
end;

{$IFDEF PoCastech}

const
  TransfVektPoCastechPtr:  PTransfVektPoCastech = nil;

{$ENDIF}


procedure TransformujSouradnici(var Sour: TSour; TransfPtr: pointer);
var
  BodZdr, BodCil: TranType.Bod;
  PoCastech: boolean;

begin
  with BodZdr do
  begin
    X:= Sour.Y; Y:= Sour.X; Z:= 0
  end;

{$IFDEF PoCastech}

  if (TransfVektPoCastechPtr <> nil) then
     PoCastech:= TransfVektPoCastechPtr^.OKTransformuj(BodZdr, BodCil)
  else PoCastech:= false;

  if not PoCastech then

{$ENDIF}

     TransformaceTransformuj(TransfPtr, BodZdr, BodCil);

  with BodCil do
  begin
    Sour.Y:= X; Sour.X:= Y
  end;
end;


procedure TransformujLinii(BlokPtr: TBlokPtr; CZaz: longInt;
                           TransfPtr: pointer);
var
  Linie:         TLin;
  Sour, PreSour: TSour;
{  JmenoDB:       pathStr;}
{  DB:            DBF; }
  CZazDB, J:     longInt;
  Delka:         real;

begin
  with BlokPtr^ do
  begin
    CtiLinii(CZaz, Linie);
    if not (ZrusenaL in Linie.Atributy) then
    begin
      IniOpObdelnik(Linie.OpsanyObdelnik);
      Delka:= 0;
      CtiSour(Linie.PrvniSour, Sour);
      TransformujSouradnici(Sour, TransfPtr);
      PisSour(Linie.PrvniSour, Sour);
      AktualizaceOpObdelnika(Sour.Y, Sour.X, Linie.OpsanyObdelnik);

      PreSour:= Sour;

      if Linie.PosledniSour > Linie.PrvniSour then
    { cyklus transformace souradnic a pocitani delky linie }
      for J:= Linie.PrvniSour+1 to Linie.PosledniSour do
      begin
        CtiSour(J, Sour);
        TransformujSouradnici(Sour, TransfPtr);
        PisSour(J, Sour);
        AktualizaceOpObdelnika(Sour.Y, Sour.X, Linie.OpsanyObdelnik);
        Delka:= Delka + VzdalenostBodu(PreSour, Sour);
        PreSour:= Sour
      end;

      Linie.Delka:= Delka;
      TransformujSouradnici(Linie.PolohaSymbolu.Sour, TransfPtr);
      PisLinii(CZaz, Linie);

{
      JmenoDB:= DejJmenoBloku + '\LIN' + LStr0(Linie.Druh, 4) + '.DBF';


      DB.Init(JmenoDB);

      if DB.NebylaChyba and (DB.PolozkaCislem('CISLO') > 0) and
                            (DB.PolozkaCislem('DELKA') > 0) then
      begin

        CZazDB:= DejCZazDBFDleIndexu1(DB, Linie.Cislo);
        if CZazDB > -1 then
        begin
          DB.NajdiZaznam(CZazDB);
          DB.AktualizujPolozku (RStr (Delka,
                                      DB.DesMistPolozky(DB.PolozkaCislem('DELKA'))),
                                DB.PolozkaCislem('DELKA'));
          DB.ZapisZaznam(CZazDB)
        end;
      end;

      DB.Done
}
    end { if nezrusena linie }
  end
end;






procedure TransformujPlochu(BlokPtr: TBlokPtr; CZaz: longInt;
                            TransfPtr: pointer);
var
  Plocha: TPlocha;

begin
  with BlokPtr^ do
  begin
    CtiPlochu(CZaz, Plocha);
    if RegulerniPlocha(Plocha) then
    begin
      Plocha.Vymera:= PlochaPlochy(Plocha, BlokPtr);
      NastavOpsanyObdelnikPlochy(Plocha, BlokPtr);
      TransformujSouradnici(Plocha.Sour, TransfPtr)
    end;

    PisPlochu(CZaz, Plocha)
  end
end;




procedure TransformujLinie(BlokPtr: TBlokPtr; TransfPtr: pointer);
var
  I: longInt;
  Retezec1, Retezec2: array[0..50] of char;

begin
  with BlokPtr^ do
  begin
    OtevriSoubory(true);

    LoadString(HInstance, 439, Retezec1, 50);
    StrPCopy(Retezec2, JmenoSouboruNa30(AdresarPrac));
    InitNM(Retezec1, Retezec2, pred(DejPocetLinii));

    for I:= 1 to DejPocetLinii-1 do
    begin
      TransformujLinii(BlokPtr, I, TransfPtr);
      PShowDlgNM(AbortDlg)^.DalsiKrok;
      KeepWindowsAlive;
    end;

    ZavriSoubory
  end
end;




procedure TransformujPlochy(BlokPtr: TBlokPtr; TransfPtr: pointer);
var
  I: longInt;
  Retezec1: array[0..50] of char;

begin
  with BlokPtr^ do
  begin
    OtevriSoubory(true);

    StrPCopy(Retezec1, JmenoSouboruNa30(AdresarPrac));
    PShowDlgNM(AbortDlg)^.ZmenTitle(Retezec1, pred(DejPocetPloch));
    for I:= 1 to pred(DejPocetPloch) do
    begin
      TransformujPlochu(BlokPtr, I, TransfPtr);
      PShowDlgNM(AbortDlg)^.DalsiKrok;
      KeepWindowsAlive;
    end;

    ZavriSoubory
  end
end;





procedure TransformujBodyBloku(BlokPtr: TBlokPtr; TransfPtr: pointer);
var
  I: longInt;
  Bod: TBod;
  Retezec1: array[0..50] of char;

begin
  with BlokPtr^ do
  begin
    OtevriSoubory(true);

    StrPCopy(Retezec1, JmenoSouboruNa30(AdresarPrac));
    PShowDlgNM(AbortDlg)^.ZmenTitle(Retezec1, pred(DejPocetBodu));
    for I:= 1 to pred(DejPocetBodu) do
    begin
      CtiBod(I, Bod);
      if not (ZrusenB in Bod.Atributy) then
      begin
        TransformujSouradnici(Bod.Sour, TransfPtr);
        PisBod(I, Bod)
      end;
      PShowDlgNM(AbortDlg)^.DalsiKrok;
      KeepWindowsAlive;
    end;

    ZavriSoubory
  end
end;




procedure TransformujTextyBloku(BlokPtr: TBlokPtr; TransfPtr: pointer);
var
  I: longInt;
  TextInfo: TText;
  Retezec1: array[0..50] of char;

begin
  with BlokPtr^ do
  begin
    OtevriSoubory(true);

    StrPCopy(Retezec1, JmenoSouboruNa30(AdresarPrac));
    PShowDlgNM(AbortDlg)^.ZmenTitle(Retezec1, fileSize(FTextu)-1);
    for I:= 1 to fileSize(FTextu) - 1 do
    begin
      CtiTextBezRetezce(I, TextInfo);
      if not (ZrusenT in TextInfo.Atributy) then
      begin
        TransformujSouradnici(TextInfo.VychoziBod, TransfPtr);
        TransformujSouradnici(TextInfo.OpsanyObdelnik.PH, TransfPtr);
        TransformujSouradnici(TextInfo.OpsanyObdelnik.LD, TransfPtr);
        PisTextBezRetezce(I, TextInfo)
      end;
      PShowDlgNM(AbortDlg)^.DalsiKrok;
      KeepWindowsAlive;
    end;

    Dispose(AbortDlg, Done);

    ZavriSoubory
  end
end;






procedure TransformujBlok(BlokPtr: TBlokPtr; TransfPtr: pointer);
var
  RozmerBloku: TObdelnik;
  Adresa: longInt;

begin
  with BlokPtr^ do
  begin
    DejRozmerBloku(RozmerBloku);

    if DobryObdelnik(RozmerBloku) or BodovyObdelnik(RozmerBloku) then
    begin
      TransformujLinie(BlokPtr, TransfPtr);
      TransformujPlochy(BlokPtr, TransfPtr);
      TransformujBodyBloku(BlokPtr, TransfPtr);
      TransformujTextyBloku(BlokPtr, TransfPtr);
    end;

    if State^.ZobrOkno <> nil then
    begin
      Adresa := longInt(@AdresarPrac);
      SendMessage(Application^.MainWindow^.HWindow, wm_ZobrazVseOknaSBlokem, 0, Adresa);
    end;
  end
end;


{$IFDEF PoCastech}

function Vyhovuje(
                  TransfPtr: pointer): boolean;
begin
  if  TransformaceDejPocetIdB(TransfPtr) >= 4 then
    Vyhovuje := true
  else
    Vyhovuje := false;
end;

procedure TransformaceCelehoPoCastech(
                                      var Parametr); far;
var
  Transformace: pointer;

begin
  Transformace := pointer(Parametr);
  if Transformace <> nil then
  begin
    if Vyhovuje(Transformace) then
    begin
      TransfVektPoCastechPtr:= New(PTransfVektPoCastech, Init(Transformace));
      TransformujBlok(PredmetZajmu^.DejAktBlokPtr, Transformace);
      Dispose(TransfVektPoCastechPtr, Done);
      TransfVektPoCastechPtr:= nil
    end;
    TransformaceDone(Transformace);
  end;
end;

{$ENDIF}


procedure TransformaceCeleho(
                             var Parametr); far;
var
  Transformace: pointer;

begin
  Transformace := pointer(Parametr);
  if Transformace <> nil then
  begin
    TransformujBlok(PredmetZajmu^.DejAktBlokPtr, Transformace);
    TransformaceDone(Transformace);
  end;
end;

const
  PocetPruchodu: longInt = 0;



procedure TransformaceLinie(
                            var Parametr); far;
type
  PTransLinRec = ^TransLinRec;
  TransLinRec = record
                  Transformace: pointer;
                  CisloLinie  : longint;
                  EscDone     : boolean;
                end;

var
  TransLin    : PTransLinRec;
  Adresa      : longint;

begin
  TransLin := PTransLinRec(Parametr);
  if TransLin <> nil then
  begin
    if not TransLin^.EscDone then
    begin
      inc(PocetPruchodu);

      with TransLin^, PredmetZajmu^.DejAktBlokPtr^ do
        if Transformace <> nil then
        begin
          OtevriSoubory(true);
          TransformujLinii(PredmetZajmu^.DejAktBlokPtr, CisloLinie, Transformace);
          ZavriSoubory;
        end;

      VyberLinieProTr(TransLin^.Transformace);
    end else
    begin
      if TransLin^.Transformace <> nil then
        TransformaceDone(TransLin^.Transformace);

      if PocetPruchodu > 0 then
      begin
        with PredmetZajmu^.DejAktBlokPtr^ do
          Adresa := longInt(@AdresarPrac);
        SendMessage(Application^.MainWindow^.HWindow, wm_ZobrazVseOknaSBlokem, 0, Adresa);
      end;

      PocetPruchodu := 0;
    end;
  end;
end;

procedure VyberLinieProTr(
                          var Parametr);
var
  VyberLinie: PVyberLinProTransf;
begin
  New(VyberLinie, Init(State, false, TransformaceLinie, pointer(Parametr)));
  VyberLinie^.Select;
end;


procedure TransformaceTabletu(
                              var Parametr);
var
  TransformaceProtokol: PTransformaceProtokol;
begin
  TransformaceProtokol := pointer(Parametr);
  if TransformaceProtokol <> nil then
  begin
    TransformaceTablet := TransformaceProtokol^.Transformace;

    with PWindow(Application^.MainWindow)^ do
      if TransformaceTablet <> nil then
        CheckMenuItem(GetMenu(HWindow), cm_Tablet, mf_ByCommand or mf_Checked)
      else
      begin
        if TabletPtr <> nil then
        begin
          Dispose(TabletPtr, Done);
          TabletPtr := nil;
        end;

        CheckMenuItem(GetMenu(HWindow), cm_Tablet, mf_ByCommand or mf_UnChecked);
      end;
    Dispose(TransformaceProtokol);
    TransformaceProtokol := nil;
  end;
end;




procedure VyberIdBoduZObrazovky(
                                Druh: word);
var
  IdBodyZObrazovky: PSnimacIdBodu;
  aProcedura: TProcedura;
  JmTrTab: TPathStr;
  Cesta: TDirStr;
  Jmeno: TNameStr;
  Ext: TExtStr;
  NazevTransformaceIdB: TNazevTran;

begin
  if true then
  begin
    FileSplit(PredmetZajmu^.DejAktBlokPtr^.AdresarArchiv, Cesta, Jmeno, Ext);
    StrCopy(JmTrTab, Cesta);
    StrCat (JmTrTab, Jmeno);
    StrCat (JmTrTab, '.trt');
    case Druh of
      0: aProcedura := TransformaceCeleho;
      1: aProcedura := VyberLinieProTr;
{$IFDEF PoCastech}
      2: aProcedura := TransformaceCelehoPoCastech;
{$ENDIF}
      3: aProcedura := TransformaceTabletu;
    end;

    LoadString(HInstance, 622, NazevTransformaceIdB, 20); {O.S. 7.7.95 oprava 621 na 622}

    IdBodyZObrazovky := New(PSnimacIdBodu, Init(State, true, aProcedura, 1, false, JmTrTab,
                                                nil, false, NazevTransformaceIdB, 10024));
    IdBodyZObrazovky^.Select;
  end;
end;

procedure VyberIdBoduML(
                        Metoda, Druh: word);
var
  CilBodColl: PCilIdBodCollection;
  IdBodyZObrazovky: PSnimacIdBodu;
  aProcedura: TProcedura;
  JmTrTab: TPathStr;
  Cesta: TDirStr;
  Jmeno: TNameStr;
  Ext: TExtStr;
  NazevTransformaceIdB: TNazevTran;

begin
  if VratParametryML(Metoda, CilBodColl) then
  begin
    FileSplit(PredmetZajmu^.DejAktBlokPtr^.AdresarArchiv, Cesta, Jmeno, Ext);
    StrCopy(JmTrTab, Cesta);
    StrCat (JmTrTab, Jmeno);
    StrCat (JmTrTab, '.trt');
    case Druh of
      0: aProcedura := TransformaceCeleho;
      1: aProcedura := VyberLinieProTr;
{$IFDEF PoCastech}
      2: aProcedura := TransformaceCelehoPoCastech;
{$ENDIF}
      3: aProcedura := TransformaceTabletu;
    end;

    LoadString(HInstance, 621, NazevTransformaceIdB, 20);

    IdBodyZObrazovky := New(PSnimacIdBodu, Init(State, true, aProcedura, 1, false, JmTrTab,
                                                CilBodColl, true, NazevTransformaceIdB, 10024));
    IdBodyZObrazovky^.Select;
  end;
end;



procedure VyberIdBoduObdelnik(
                              Druh: word);
var
  CilBodColl: PCilIdBodCollection;
  IdBodyZObrazovky: PSnimacIdBodu;
  aProcedura: TProcedura;
  JmTrTab: TPathStr;
  Cesta: TDirStr;
  Jmeno: TNameStr;
  Ext: TExtStr;
  NazevTransformaceIdB: TNazevTran;

begin
  if VratParametryObdelniku(CilBodColl) then
  begin
    FileSplit(PredmetZajmu^.DejAktBlokPtr^.AdresarArchiv, Cesta, Jmeno, Ext);
    StrCopy(JmTrTab, Cesta);
    StrCat (JmTrTab, Jmeno);
    StrCat (JmTrTab, '.trt');
    case Druh of
      0: aProcedura := TransformaceCeleho;
      1: aProcedura := VyberLinieProTr;
{$IFDEF PoCastech}
      2: aProcedura := TransformaceCelehoPoCastech;
{$ENDIF}
      3: aProcedura := TransformaceTabletu;
    end;

    LoadString(HInstance, 621, NazevTransformaceIdB, 20);

    IdBodyZObrazovky := New(PSnimacIdBodu, Init(State, true, aProcedura, 1, false, JmTrTab,
                                                CilBodColl, false, NazevTransformaceIdB, 10024));
    IdBodyZObrazovky^.Select;
  end;
end;


procedure NacteniTransfTabulky(
                               Druh: word);
var
  CilBodColl: PCilIdBodCollection;
  IdBodyZObrazovky: PSnimacIdBodu;
  aProcedura: TProcedura;
  JmTrTab: TPathStr;
  NazevTransformaceIdB: TNazevTran;
  i, PomCislo: longInt;

begin
  if NactiTransfTabulku(CilBodColl, JmTrTab, NazevTransformaceIdB) then
  begin
    case Druh of
      0: aProcedura := TransformaceCeleho;
      1: aProcedura := VyberLinieProTr;
{$IFDEF PoCastech}
      2: aProcedura := TransformaceCelehoPoCastech;
{$ENDIF}
      3: aProcedura := TransformaceTabletu;
    end;

    PomCislo := 0;
    for i := 0 to pred(CilBodColl^.Count) do
      if PCilIdBod(CilBodColl^.At(i))^.cCislo > PomCislo then
        PomCislo := PCilIdBod(CilBodColl^.At(i))^.cCislo;
    IdBodyZObrazovky := New(PSnimacIdBodu, Init(State, true, aProcedura, PomCislo+1,
                                                false, JmTrTab, CilBodColl, false, NazevTransformaceIdB, 10024));
    IdBodyZObrazovky^.Select;
  end;
end;


procedure NacteniIdBZDB(
                        Druh: word);
var
  CilBodColl: PCilIdBodCollection;
  IdBodyZObrazovky: PSnimacIdBodu;
  aProcedura: TProcedura;
  JmTrTab: TPathStr;
  NazevTransformaceIdB: TNazevTran;

begin
  if NactiIdBZDB(CilBodColl, JmTrTab) then
  begin
    case Druh of
      0: aProcedura := TransformaceCeleho;
      1: aProcedura := VyberLinieProTr;
{$IFDEF PoCastech}
      2: aProcedura := TransformaceCelehoPoCastech;
{$ENDIF}
      3: aProcedura := TransformaceTabletu;
    end;

    LoadString(HInstance, 621, NazevTransformaceIdB, 20);

    IdBodyZObrazovky := New(PSnimacIdBodu, Init(State, true, aProcedura, 1, false, JmTrTab,
                                                CilBodColl, false, NazevTransformaceIdB, 10024));
    IdBodyZObrazovky^.Select;
  end;
end;


procedure UrciTrKlicATransformujBLK(
                                    IdB, Druh: word);
begin
  case IdB of
    0   : NacteniIdBZDB(Druh);
    1..5: VyberIdBoduML(IdB, Druh);
    6   : VyberIdBoduObdelnik(Druh);
    7   : VyberIdBoduZObrazovky(Druh);
    8   : NacteniTransfTabulky(Druh);
  end;
end;


procedure VypniTransformaciTabletu;
begin
  if TabletPtr <> nil then
  begin
    if TransformaceTablet <> nil then
    begin
      TransformaceDone(TransformaceTablet);
      TransformaceTablet := nil;
    end;

    if TabletPtr <> nil then
    begin
      Dispose(TabletPtr, Done);
      TabletPtr := nil;
    end;

    with PWindow(Application^.MainWindow)^ do
      CheckMenuItem(GetMenu(HWindow), cm_Tablet, mf_ByCommand or mf_UnChecked);
  end;
end;




end.
