unit F_GetDbDrive1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TF_GetDbDrive = class(TForm)
    GroupBox1: TGroupBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    CBox1_AliasDrivers: TComboBox;
    procedure CBox1_AliasDriversChange(Sender: TObject);
  private
    { Private declarations }
    FAliasDriver: String;
    procedure setAliasDriver(aDriver: String);
  public
    { Public declarations }
     function MyShowModal(aSList: TStringList): Integer;
     property AliasDriver: String read FAliasDriver write SetAliasDriver;
  end;

var
  F_GetDbDrive: TF_GetDbDrive;

implementation

{$R *.DFM}

procedure TF_GetDbDrive.setAliasDriver(aDriver: String);
begin
   FAliasDriver := aDriver;
end;


function TF_GetDbDrive.MyShowModal(aSList: TStringList): Integer;
begin
   if aSlist <> nil then CBox1_AliasDrivers.Items.Assign(aSList);

   Result := ShowModal;

end;



procedure TF_GetDbDrive.CBox1_AliasDriversChange(Sender: TObject);
begin
   AliasDriver:= CBox1_AliasDrivers.Text;

end;

end.
