unit F_SaveAs;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TFSaveAs = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    procedure Edit1Change(Sender: TObject);
  private
    { Private declarations }
    FTextDlg: String;
    FCaptionDlg: String;

  public
    { Public declarations }
    procedure SetCaptionDlg(aText: String);
    procedure SetTextDlg(aText: String);

    property TextDlg: String read FTextDlg write SetTextDlg;
    property CaptionDlg: String read FCaptionDlg write SetCaptionDlg;
  protected
  end;

var
  FSaveAs: TFSaveAs;

implementation

{$R *.DFM}

procedure TFSaveAs.SetTextDlg(aText: String);
begin
   FTextDlg := aText;
   Edit1.Text := FTextDlg;
end;



procedure TFSaveAs.SetCaptionDlg(aText: String);
begin
   FCaptionDlg := aText;
   Caption := FCaptionDlg;
end;



procedure TFSaveAs.Edit1Change(Sender: TObject);
begin
   TextDlg := Edit1.Text;
end;


end.
