unit T_edit;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,
  Elements, Tools, StdCtrls, Buttons;

type
  TT_editForm = class(TForm)
    Edit: TEdit;
    btOK: TBitBtn;
    CB: TComboBox;
  private
    { Private declarations }
  public
    { Public declarations }
  end;



TEditTool = class(TTool)
private
  FEdForm: TT_EditForm;
  FText: string;
public
  procedure DoIt; override;
published
  property Text: string read FText write FText;
end;

implementation

{$R *.DFM}

procedure TEditTool.DoIt;
begin
  FEdForm:= TT_EditForm.Create(Application);
  FEdForm.Edit.Text:= Text;
  FEdForm.ShowModal;
  Text:= FEdForm.Edit.Text
end;


end.
