unit r_MapManagerFrame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  r_OrbisFrame, StdCtrls, Buttons, Menus;

type
  TMapManager_Frame = class(TOrbis_Frame)
    Combo: TComboBox;
    SpeedButton1: TSpeedButton;
    PopupMenu1: TPopupMenu;
    Novmapy1: TMenuItem;
    Nastavenvrstev1: TMenuItem;
    Zapnout1: TMenuItem;
    Vypnoutvechnyvrstvy1: TMenuItem;
    Profilymap1: TMenuItem;
    procedure ComboChange(Sender: TObject);
    procedure ComboDblClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Nastavenvrstev1Click(Sender: TObject);
    procedure Novmapy1Click(Sender: TObject);
    procedure Vypnoutvechnyvrstvy1Click(Sender: TObject);
    procedure Zapnout1Click(Sender: TObject);
    procedure Profilymap1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


implementation
uses
   m_Proj;

{$R *.DFM}

procedure TMapManager_Frame.ComboChange(Sender: TObject);
begin
   inherited;
   Tool.SetPropertyStringByName('MapChange','true');
   //ShowMessage('Map change');
end;

procedure TMapManager_Frame.ComboDblClick(Sender: TObject);
begin
   Tool.SetPropertyStringByName('Setting','true');
end;

procedure TMapManager_Frame.SpeedButton1Click(Sender: TObject);
begin
   Tool.SetPropertyStringByName('Setting','true');
end;

procedure TMapManager_Frame.Nastavenvrstev1Click(Sender: TObject);
begin
   Tool.SetPropertyStringByName('Setting','true');
end;

procedure TMapManager_Frame.Novmapy1Click(Sender: TObject);
begin
   Tool.PostTextMsg(tm_Run,'LED\NewMaps.OIL',nil);
end;

procedure TMapManager_Frame.Vypnoutvechnyvrstvy1Click(Sender: TObject);
begin
   Tool.PostTextMsg(tm_Run,'LED\Maps_Actual_SwitchOff.OIL',nil);
   Application.ProcessMessages;
   Application.ProcessMessages;
   Tool.SetPropertyStringByName('Setting','true');
end;

procedure TMapManager_Frame.Zapnout1Click(Sender: TObject);
begin
   Tool.PostTextMsg(tm_Run,'LED\Maps_Actual_SwitchOn.OIL',nil);
   Application.ProcessMessages;
   Application.ProcessMessages;
   Tool.SetPropertyStringByName('Setting','true');
end;

procedure TMapManager_Frame.Profilymap1Click(Sender: TObject);
begin
   Tool.PostTextMsg(tm_Run,'LED\Etc\Maps\Profiles\Maps_Profiles.OIL',nil);
   Application.ProcessMessages;
   Application.ProcessMessages;
   //Tool.SetPropertyStringByName('Setting','true');
end;

end.
