unit f_ConditionFilter;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Buttons, ComCtrls, ToolWin, ExtCtrls,
  Tools, Menus;

type
  TConditionFilterForm = class(TForm)
    CoolBar1: TCoolBar;
    SG: TStringGrid;
    ToolBar1: TToolBar;
    b_New: TBitBtn;
    b_Open: TBitBtn;
    b_Save: TBitBtn;
    b_SaveAs: TBitBtn;
    CoolBar2: TCoolBar;
    Panel1: TPanel;
    Panel2: TPanel;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolBar2: TToolBar;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    PopupMenu1: TPopupMenu;
    Vyhoditdek1: TMenuItem;
    procedure SGKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    FModified: boolean;
    FTool: TTool;
    procedure SetModified(const Value: boolean);
    procedure SetTool(const Value: TTool);
    { Private declarations }
  public
     property Tool: TTool read FTool write SetTool;
     property Modified: boolean read FModified write SetModified;
    { Public declarations }
  end;


implementation

{$R *.DFM}

{ TConditionFilterForm }

procedure TConditionFilterForm.SetModified(const Value: boolean);
begin
  FModified := Value;
end;

procedure TConditionFilterForm.SetTool(const Value: TTool);
begin
  FTool := Value;
end;

procedure TConditionFilterForm.SGKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if SG.Selection.Top = SG.RowCount - 1 then
   begin
      if (Key = VK_RETURN) or (Key = VK_DOWN) then
      begin
         SG.RowCount := SG.RowCount + 1;
      end;
   end;
end;

end.
