{$D+}
unit F_STD;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Menus, Buttons, ExtCtrls, ComCtrls,
  e_Device,
  Elements,
  t_Device,
  Tools;

type
  TStandardForm = class(TForm)
    MainMenu: TMainMenu;
    View: TMenuItem;
    Tools: TMenuItem;
    Prezobraz: TMenuItem;
    Print: TMenuItem;
    Tiskni: TMenuItem;
    Nastaveni: TMenuItem;
    PrintDialog: TPrintDialog;
    PrinterSetupDialog: TPrinterSetupDialog;
    PopupMenu1: TPopupMenu;
    meritko: TMenuItem;
    All: TMenuItem;
    ToolBar: TPanel;
    PaintBox: TPaintBox;
    Image: TImage;
    btn_Link: TBitBtn;
    PopupMenu2: TPopupMenu;
    Nahoe1: TMenuItem;
    Dole1: TMenuItem;
    Vlevo1: TMenuItem;
    Vpravo1: TMenuItem;
    Plovouc1: TMenuItem;
    Nastaven1: TMenuItem;
    N1: TMenuItem;
    Storno1: TMenuItem;
    Model1: TMenuItem;
    Storno2: TMenuItem;
    Panel1: TPanel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    l_x: TLabel;
    l_y: TLabel;
    Mtko1: TMenuItem;
    Vevevezu1: TMenuItem;
    Pezobraz1: TMenuItem;
    Soubor1: TMenuItem;
    Uloitpodnzvem1: TMenuItem;
    Otevt1: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    Bevel4: TBevel;
    Label3: TLabel;
    l_M: TLabel;
    N2: TMenuItem;
    Struktura1: TMenuItem;
    procedure PrezobrazClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SouradniceClick(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure TiskniClick(Sender: TObject);
    procedure NastaveniClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormResize(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure meritkoClick(Sender: TObject);
    procedure AllClick(Sender: TObject);
    procedure btn_LinkDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure btn_LinkDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Model1Click(Sender: TObject);
    procedure Storno2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Otevt1Click(Sender: TObject);
    procedure Uloitpodnzvem1Click(Sender: TObject);
    procedure Struktura1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
  private
    IsActive: boolean;
    IsPickUpMode: boolean;
    {
    ShiftRect: TRect;
    }
  public
    IsPossibleToClose: boolean;
    Tool: TDeviceTool;
  end;


implementation
uses
{  d_STD, !!!!!!!!!!!!!!!!!}

{$IFNDEF NOTIS}
//  c_WView,
//  f_WView,
{$ENDIF}

  // KERNEL
  M_Orbis,
  Worlds,
  // GLIB
  g_Elems,
  // DEVICE
  e_Proje,
  // INTERPRET
  i_Basic,
  // GUI
  f_SetScl,
  t_InterA,

  m_Proj; {!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
  {
  e_TopMDL,
  }
//  e_Desktp,
//  e_View,
  {MapLSMO,}

{$R *.DFM}


procedure TStandardForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if IsPossibleToClose then  CanClose:= true
  else
  begin
    CanClose:= false;
    IsPossibleToClose := true;
    Tool.PostMsg(tm_QuitTask, Tool, nil, DontKill);
  end
end;




procedure TStandardForm.PrezobrazClick(Sender: TObject);
begin
  Tool.PostMsg(tm_BreakInterpret, Tool, nil, DontKill);
  Application.ProcessMessages;
  Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
end;


procedure TStandardForm.SouradniceClick(Sender: TObject);
begin
  {
  Post(tm_AddCoordsView, 0)
  }
end;

procedure TStandardForm.FormMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
   begin
      Tool.PostMouseEvent(tm_MouseMove, Tool, mbLeft, Shift, X, Y, IsActive);
   end;
  {
  if isActive and not isPickUpMode then
  if  ssLeft in Shift then
  begin
     with ShiftRect do PaintBox.Canvas.Rectangle(Left, Top, Right, Bottom);
     ShiftRect.Right  := x;
     ShiftRect.Bottom := y;
     with ShiftRect do PaintBox.Canvas.Rectangle(Left, Top, Right, Bottom);
  end;
  }
end;

procedure TStandardForm.TiskniClick(Sender: TObject);
begin
  Tool.PostMsg(tm_Print, Tool, nil, DontKill);
end;

procedure TStandardForm.NastaveniClick(Sender: TObject);
begin
  PrinterSetupDialog.Execute
end;

procedure TStandardForm.FormCreate(Sender: TObject);
begin
   IsPossibleToClose := false;
   IsActive := true;
end;

procedure TStandardForm.FormMouseDown(Sender: TObject;
   Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   begin
      Tool.PostMouseEvent(tm_MouseDown, Tool, Button, Shift, X, Y, IsActive);
   end;
   {
   if IsActive then
   begin
     if isPickUpMode then
     begin
       if Button = mbLeft then
       begin
         TCanvasDevice(Tool.Device).CurX:= X;
         TCanvasDevice(Tool.Device).CurY:= Y;
         Tool.PostMsg(tm_PickUpObject, Tool, nil)
       end
       else
       if Button = mbRight then
       begin
       end
     end
     else
     if Button = mbLeft then
     begin
        PaintBox.Canvas.Pen.Mode  := pmXOR;
        PaintBox.Canvas.Pen.Color := clGreen;
        ShiftRect := Rect(x,y,x,y);
        PaintBox.Canvas.Pen.Width := 3;
        with ShiftRect do PaintBox.Canvas.Rectangle(Left, Top, Right, Bottom);
     end;
   end
   }
end;

procedure TStandardForm.FormMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
   R: TDoubleRect;
   aTool: TTool;
begin
    begin
      Tool.PostMouseEvent(tm_MouseUp, Tool, Button, Shift, X, Y, IsActive);
    end;
    IsActive := true;
    (*
    if IsActive and not isPickUpMode then
    if Button = mbLeft then
    begin
       with ShiftRect do Canvas.Rectangle(Left, Top, Right, Bottom);
       PaintBox.Canvas.Pen.Mode  := pmCopy;
       PaintBox.Canvas.Pen.Color := clBlack;
       PaintBox.Canvas.Pen.Width := 1;
       with ShiftRect do
       begin
          if (Right-Left <= 2) and (Bottom - Top <= 2) then
          begin
             TCanvasDevice(Tool.Device).Projection.CenterPoint := TCanvasDevice(Tool.Device).Projection.GetModelPoint(x,y);
             Tool.PostMsg(tm_ReView, Tool, nil);
             exit;
          end
          else
             R := TCanvasDevice(Tool.Device).Projection.GetModelRect(Left, Top, Right, Bottom);
       end;
       {
       if ssCtrl in Shift then
       begin
         aTool:= TTechnology(World.MainTool).AddTool(TInterpretBloku.Create);
         if assigned(aTool) then
         begin
           aTool.Input:= TEntity(World.ObjectModel).FindElementClass(TTopoLPredmetZajmu);
           TInterpret(aTool).Device := TVMSDevice.Create;
           TInterpret(aTool).Device.Projection.ChangeProjectionByRect(R,
                                                      TInterpret(aTool).Device.Page);

           TInterpret(aTool).Device.Page.Color:= clWhite;
           TInterpret(aTool).Device.Reset;
           aTool.DoIt;
           TInterpret(aTool).Device.Close
         end;
       end
       else
       }
       begin
          TCanvasDevice(Tool.Device).Projection.ModelView := R;
          Tool.PostMsg(tm_ReView, Tool, nil);
       end;
    end;
    IsActive := true;
    *)
end;



procedure TStandardForm.FormResize(Sender: TObject);
begin
   try
      if not Visible then exit;
      if Tool = nil then exit;
      Tool.PostMsg(tm_ReSize, Tool, nil, DontKill);
      {
      Tool.Device.SetupPage(nil);
      Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
      }
   except
   end;
end;


procedure TStandardForm.FormDeactivate(Sender: TObject);
begin
   {
   TCanvasToBMPDevice(Tool.Device).Background := true;
   }
   IsActive := false;
end;

procedure TStandardForm.meritkoClick(Sender: TObject);
{
var
   form: TF_SetScale;
   D: double;
   Code: integer;
   R: TDoubleRect;
   PZ : TRectEntity;
}
begin
   Tool.PostMsg(tm_BreakInterpret, Tool, nil, DontKill);
   Application.ProcessMessages;
   Tool.PostMsg(tm_NewScale, Tool, nil, DontKill);
{
   Form:= TF_SetScale.Create(Application);
   Form.ComboBox.Text := IntToStr(round(Tool.Device.Projection.Scale));
   case Form.ShowModal of
      mrOK:
      begin
         Val(Form.ComboBox.Text, D, Code);
         if Code > 0 then
         begin
            PZ := TRectEntity(TInterpret(Tool.Device.FindOwnerClass(TInterpret)).Input);
            with TRectangle(PZ.Rect) do
            begin
               R.Min.X:= Min.X;
               R.Min.Y:= Min.Y;
               R.Max.X:= Max.X;
               R.Max.Y:= Max.Y;
            end;
           Tool.Device.Projection.ChangeProjectionByRect(R, Tool.Device.Page);
         end
         else
            Tool.Device.Projection.Scale := D;
         Tool.PostMsg(tm_BreakAndReView, Tool, nil, DontKill);
      end;
   end;
   Form.Free;
}
end;

procedure TStandardForm.AllClick(Sender: TObject);
{
var
   R: TDoubleRect;
   PZ: TRectEntity;
}
begin
   Tool.PostMsg(tm_BreakInterpret, Tool, nil, DontKill);
   Application.ProcessMessages;
   Tool.PostMsg(tm_ShowAll, Tool, nil, DontKill);
{
   PZ := TRectEntity(TInterpret(Tool.Device.FindOwnerClass(TInterpret)).Input);
   with TRectangle(PZ.Rect) do
   begin
      R.Min.X:= Min.X;
      R.Min.Y:= Min.Y;
      R.Max.X:= Max.X;
      R.Max.Y:= Max.Y;
   end;
   Tool.Device.Projection.ChangeProjectionByRect(R, Tool.Device.Page);
   Tool.PostMsg(tm_BreakAndReView, Tool, nil, DontKill);
}
end;



procedure TStandardForm.btn_LinkDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
   Outl: TTreeView;
   Model: TElement;
{$IFNDEF NOTIS}
(*
var
   Model: TElement;
   View, View2: TView;
   HText, DText: TText;
   Form: TStandardForm;
   Stred, StredListu: TDoubleCoord;
   NazevListu: string;
   DeskTop: TEntity;
   Outl: TWorldOutline;
   Element: TElement;
   FTM: TFormToolManager;
   DP: TDoubleCoord;
   i: longInt;
*)
{$ENDIF}
begin
      if Source is TTreeView then
      begin
         Outl  := TTreeView(Source);
         Model:= TElement(Outl.Selected.Data).CreateEnvelope;
         if Tool.Input is TRectEntity then
            TRectEntity(Tool.Input).AddAndUpdateRect(Model);
         Tool.PostMsg(tm_BreakAndReView, Tool, Model, DontKill);

{         Model := TElement(Outl.Items[Outl.SelectedItem].Data).CreateEnvelope;
         if Tool.Input is TRectEntity then
            TRectEntity(Tool.Input).AddAndUpdateRect(Model);
         Tool.PostMsg(tm_BreakAndReView, Tool, Model, DontKill);
}
      end;

(*
{$IFNDEF NOTIS}
   {
   if (Source is TBitBtn) and (TBitBtn(Sender).Owner is TViewMapScreenForm) and not
   (TInterpret(TViewMapScreenForm(TBitBtn(Sender).Owner).Device.Owners[0]).Input is TDesktop) and
   (TInterpret(Device.Owners[0]).Input is TDesktop) then
   }
   SetFocus;
   Desktop := TEntity(TEntity(Tool.Input).FindElementClass(TDeskTop));
   FTM := TFormToolManager(Tool);
   DP := TPageProjection(FTM.Projection).GetModelPoint(x,y);
   if DeskTop = nil then
   begin
   { obyejn form tool manager bez DeskTopu }
      if Source is TWorldOutline then
      begin
         Outl  := TWorldOutline(Source);
         Model := TElement(Outl.Items[Outl.SelectedItem].Data).CreateEnvelope;
         if Tool.Input is TRectEntity then
            TRectEntity(Tool.Input).AddAndUpdateRect(Model);
         Tool.PostMsg(tm_BreakAndReView, Tool, Model, DontKill);
      end;
   end
   else
   if not (Sender = Source) then
   begin
      for i := Desktop.Count - 1 downto 0 do
      begin
         if Desktop.Elements[i] is TView then
         begin
            View := TView(Desktop.Elements[i]);
            if View.PointIsInside(DP.x, DP.y) then
            begin
               if Source is TBitBtn then
               begin
                 Form:= TStandardForm(TBitBtn(Source).Owner);
                 if (Form.Tool = nil) then exit;
                 if not (Form.Tool is TFormToolManager) then exit;
                 if (Form.Tool.Input = nil) then Exit;
                 if TEntity(Form.Tool.Input).FindElementClass(TDesktop) <> nil then exit;
                 View.Model := Form.Tool.Input;
                 View.Projection.CenterPoint := Form.Tool.Device.Projection.CenterPoint;
                 View.Projection.Scale := Form.Tool.Device.Projection.Scale;
                 Tool.PostMsg(tm_BreakAndReView, Tool, nil, DontKill);
               end
               else
               if Source is TWorldOutline then
               begin
                  Outl  := TWorldOutline(Source);
                  Element:= TElement(Outl.Items[Outl.SelectedItem].Data);
                  if Element is TProjection then
                  begin
                    View.Projection.CenterPoint := TProjection(Element).CenterPoint;
                    View.Projection.Scale       := TProjection(Element).Scale;
                  end
                  else
                  if Element is TRectEntity then
                  begin
                     if View.Model is TRectEntity then
                     begin
                        TRectEntity(View.Model).AddAndUpdateRect(Element)
                     end
                     else
                        if View.Model = nil then View.Model := Element
                                            else TEntity(View.Model).AddElement(Element);
                  end;

                  Tool.PostMsg(tm_BreakAndReView, Tool, Model, DontKill);
               end;

            end;
         end;
      end;
   end;
{$ENDIF}
*)
end;


procedure TStandardForm.btn_LinkDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
(*
{$IFNDEF NOTIS}
   if (Sender <> Source) then
   begin
      if (Source is TWorldOutline) then
         Tf_WorldView(TWorldOutline(Source).Owner).DragObject := Self;
      accept := true;
   end
   else accept := false;
{$ELSE}
   accept := false;
{$ENDIF}
*)
end;

procedure TStandardForm.Model1Click(Sender: TObject);
begin
   Tool.PostMsg(tm_Explore, World.MainTool, Tool.Input, DontKill);
end;

procedure TStandardForm.Storno2Click(Sender: TObject);
begin
   Tool.PostKeyEvent(tm_KeyDown, Tool, VK_ESCAPE, []);
end;



procedure TStandardForm.FormActivate(Sender: TObject);
begin
   {
   TCanvasToBMPDevice(Tool.Device).BackGround := false;
   }
end;


procedure TStandardForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   Tool.PostKeyEvent(tm_KeyDown, Tool, Key, Shift);
end;

procedure TStandardForm.Otevt1Click(Sender: TObject);
begin
   Tool.PostMsg(tm_Open, Tool, nil, DontKill);
end;

procedure TStandardForm.Uloitpodnzvem1Click(Sender: TObject);
begin
   Tool.PostMsg(tm_SaveAs, Tool, nil, DontKill);
end;

procedure TStandardForm.Struktura1Click(Sender: TObject);
begin
   Tool.PostMsg(tm_Explore, World.MainTool, Tool, DontKill)
end;

procedure TStandardForm.PopupMenu1Popup(Sender: TObject);
begin
   Tool.PostMsg(tm_BreakInterpret, Tool, nil, DontKill);
   Application.ProcessMessages;
end;

END.
