unit T_Errors;
interface
uses SysUtils;

type

TLangError=class(Exception){sel by dat i tichy exception}
private
 FErrorNumber:integer;
 FLine:integer;
public
  constructor CreateError(aErrorNum:integer{;StToAdd:string});
  property Line:integer read FLine write FLine;
  property ErrorNumber:integer read FErrorNumber write FErrorNumber;
end;

TRunTimeError=class(TLangError)
end;

TCompilerError=class(TLangError){sel by dat i tichy exception}
private
  FLine:integer;
  FPosition:integer;
public
  constructor CreatePos(aErrorNum,aLine,aPos:integer;StToAdd:string);
  property Line:integer read FLine write FLine;
  property Position:integer read FPosition write FPosition ;
end;



implementation
const RunTime=200;
      MaxCompErr=25;
      MaxRunTimeErr=20;


const CompileEr:array[1..MaxCompErr] of string[75]=
  {*1}   ('Oekvm ',
  {2}    'Zde nesm bt ',
  {*3}    'Chyba v syntaxi',
  {4}    'Nen povoleno pouit promnn volan odkazem',
  {*5}    'Pli mnoho promnnch',
  {*6}    'Nen ordinln typ',
  {*7}    'Nepovolen typ',
  {*8}   'Typov neshoda',
  {*9}   'Nedv ukazatel na prvek',
  {*10}   'Neznm typ',
  {*11}   'Promnn ji existuje',
  {*12}   'Properta ji byla zadna',
  {*13}   'Neznm nstroj',
  {*14}   'Properta neexistuje',
  {*15}   'Neznm identifiktor',
  {*16}   'Neuzaven etzec',
  {*17}   'Neoekvan konec souboru',
  {18}   'Pli mnoho parametr',
  {*19}  'Kolize mezi NameDivider a OwnerDivider',
  {*20}  'Tento znak nen povolen: ',
  {*21}  'Identifiktor byl ji pouit',
  {22}    '',
  {23}   '',
  {24}    '',
	{25}    '');

const RunTimeEr:array[1..MaxCompErr] of string[75]=
  {1}   ('Nevysliteln vraz',
  {2}    'Nevyjditeln promnn',
  {3}    'Typov neshoda',
  {4}    'Objekt nen TElement',
  {5}    'patn jmno property',
  {6}    'Prvek neexistuje',
  {7}    'Piazen nelze provst',
  {8}    'Input mus bt prvek nikoliv hodnota',
  {9}    'Nen zadan dn nstroj',
  {10}   'Nen boolean',
  {11}   'Nen ordinrn typ',
  {12}   'Vnitn chyba',
  {13}   'patn typ pro case',
  {14}   'Objekt nen TEntity',
  {15}   'Nepouiteln typ property',
  {16}   '',
  {17}   '',
    '','','','','','','',''
       );


constructor TLangError.CreateError(aErrorNum:integer{;StToAdd:string});
begin
  inherited create(RunTimeEr[aErrorNum]);
  ErrorNumber:=aErrorNum;
  Line:=-1;
end;


constructor TCompilerError.CreatePos(aErrorNum,aLine,aPos:integer;StToAdd:string);
begin
  inherited create(CompileEr[aErrorNum]+StToAdd);
  ErrorNumber:=aErrorNum;
  Line:=aLine;
  Position:=apos;
end;


end.
