unit TLRastersMan_TLB;

// ************************************************************************ //
// WARNING                                                                  //
// -------                                                                  //
// The types declared in this file were generated from data read from a     //
// Type Library. If this type library is explicitly or indirectly (via      //
// another type library referring to this type library) re-imported, or the //
// 'Refresh' command of the Type Library Editor activated while editing the //
// Type Library, the contents of this file will be regenerated and all      //
// manual modifications will be lost.                                       //
// ************************************************************************ //

// PASTLWTR : $Revision:   1.11.1.63.1.0.1.0  $
// File generated on 4.11.1998 15:46:49 from Type Library described below.

// ************************************************************************ //
// Type Lib: C:\Program Files\Common Files\TopoLNT\TLRastersMan.tlb
// IID\LCID: {E9FE7844-F9FF-11D1-91FD-0040332CDCD8}\0
// Helpfile: 
// HelpString: TLRastersMan Library
// Version:    1.0
// ************************************************************************ //

interface

uses Windows, ActiveX, Classes, Graphics, OleCtrls, StdVCL, 
  TLPresentationStore_TLB;

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:      //
//   Type Libraries     : LIBID_xxxx                                    //
//   CoClasses          : CLASS_xxxx                                    //
//   DISPInterfaces     : DIID_xxxx                                     //
//   Non-DISP interfaces: IID_xxxx                                      //
// *********************************************************************//
const
  LIBID_TLRastersMan: TGUID = '{E9FE7844-F9FF-11D1-91FD-0040332CDCD8}';
  IID_IRasStore: TGUID = '{E9FE7845-F9FF-11D1-91FD-0040332CDCD8}';
  CLASS_RasStore: TGUID = '{E9FE7846-F9FF-11D1-91FD-0040332CDCD8}';
type

// *********************************************************************//
// Forward declaration of interfaces defined in Type Library            //
// *********************************************************************//
  IRasStore = interface;
  IRasStoreDisp = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                     //
// (NOTE: Here we map each CoClass to its Default Interface)            //
// *********************************************************************//
  RasStore = IRasStore;


// *********************************************************************//
// Interface: IRasStore
// Flags:     (4432) Hidden Dual OleAutomation Dispatchable
// GUID:      {E9FE7845-F9FF-11D1-91FD-0040332CDCD8}
// *********************************************************************//
  IRasStore = interface(IPresentationStore)
    ['{E9FE7845-F9FF-11D1-91FD-0040332CDCD8}']
    procedure GetRasterLogPalette(var Palette: Integer); safecall;
  end;

// *********************************************************************//
// DispIntf:  IRasStoreDisp
// Flags:     (4432) Hidden Dual OleAutomation Dispatchable
// GUID:      {E9FE7845-F9FF-11D1-91FD-0040332CDCD8}
// *********************************************************************//
  IRasStoreDisp = dispinterface
    ['{E9FE7845-F9FF-11D1-91FD-0040332CDCD8}']
    procedure GetRasterLogPalette(var Palette: Integer); dispid 11;
    function ConnectDataStore(Handle: Integer; DataStore: OleVariant): SCODE; dispid 1;
    function DisConnectDataStore(Handle: Integer; DataStore: OleVariant): SCODE; dispid 2;
    procedure DisplayAllDataStores(Handle: Integer; DC: Integer; MemoryDC: Integer; 
                                   BitMap: Integer; ShowOnDevice: WordBool); dispid 3;
    procedure DisplayDataStoresFromList(List: OleVariant; Handle: Integer; DC: Integer; 
                                        MemoryDC: Integer; BitMap: Integer; ShowOnDevice: WordBool); dispid 4;
    procedure FillAllDataStores(Handle: Integer; Buffer: Integer; TrueColorBitmap: WordBool); dispid 5;
    procedure FillDataStoresFromList(List: OleVariant; Handle: Integer; Buffer: Integer; 
                                     TrueColorBitmap: WordBool); dispid 6;
    procedure GetRectForHandle(Handle: Integer; var VertMin: Double; var HorMin: Double; 
                               var DVert: Double; var DHor: Double); dispid 7;
    function PresentationStoreConnect(Handle: Integer; QuestionCallback: Integer; 
                                      MessageCallback: Integer; InitProgressCallBack: Integer; 
                                      SetProgressTitleCallBack: Integer; 
                                      ProgressStepCallBack: Integer; 
                                      TestAbortProgressCallBack: Integer; 
                                      DisposeProgressCallBack: Integer; ViewTrf: OleVariant): SCODE; dispid 8;
    procedure PresentationStoreDisConnect(Handle: Integer); dispid 9;
    function RefreshDataStore(Handle: Integer; DataStore: OleVariant): SCODE; dispid 10;
  end;

  CoRasStore = class
    class function Create: IRasStore;
    class function CreateRemote(const MachineName: string): IRasStore;
  end;

implementation

uses ComObj;

class function CoRasStore.Create: IRasStore;
begin
  Result := CreateComObject(CLASS_RasStore) as IRasStore;
end;

class function CoRasStore.CreateRemote(const MachineName: string): IRasStore;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_RasStore) as IRasStore;
end;

end.
