unit e_Chk;

interface
uses
   e_GeometryElement;

type

TErrorGeometryElement = class (TGeometryElement)
  private
    FErrY: double;
    FErrX: double;
    FErrorCode: integer;
    procedure SetErrorCode(const Value: integer);
    procedure SetErrX(const Value: double);
    procedure SetErrY(const Value: double);
published
   property ErrorCode: integer read FErrorCode write SetErrorCode;
   property ErrX: double read FErrX write SetErrX;
   property ErrY: double read FErrY write SetErrY;
end;

TErrorElementCollection = class(TGeometryElementCollection);

implementation
uses
   e_Class;

{ TErrorGeometryElement }

procedure TErrorGeometryElement.SetErrorCode(const Value: integer);
begin
  FErrorCode := Value;
end;

procedure TErrorGeometryElement.SetErrX(const Value: double);
begin
  FErrX := Value;
end;

procedure TErrorGeometryElement.SetErrY(const Value: double);
begin
  FErrY := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TErrorGeometryElement);
   RegisterOrbisClass(TErrorElementCollection);
END.
