unit TransRas;

interface

{$IFDEF PoCastech}
function NactiMetoduTrPoCastech(
                                var IdB : word): boolean;
{$ENDIF}
function NactiMetodu(
                     var IdB, Obl: word): boolean;

procedure UrciTrKlicATransformuj(
                                 IdB, Obl: word);
{$IFDEF PoCastech}
procedure UrciTrKlicATransformujPoCastech(
                                          IdB: word);
{$ENDIF}
implementation

uses WinTypes, OWindows, ODialogs, WinDos, Strings, WinProcs,
     StrProc, MatProc, TranType,
     TranMet, Hlasky,
     BlokType,
     RasOpDLL,
     OrezLin,
     RAsMNDll, RastProc,
     Pokus, Pokus1,
     IdBody, TranRast,
{$IFDEF PoCastech}
     TrRasPCN,
{$ENDIF}
     ZobrTran,
     DialInc,
     VyrezOkn;


function NactiMetodu(
                     var IdB, Obl: word): boolean;

type
  TMetodaTrData = record
    IdBody: array[0..8] of word;
    Oblast: array[0..3] of word;
  end;

var
  Data: TMetodaTrData;
  Dlg: PTranMetDlg;
  RB: PRadioButton;
  i: word;
  Retezec1: array[0..50] of char;

begin
  with Data do
  begin
    IdBody[0] := bf_UnChecked;
    IdBody[1] := bf_UnChecked;
    IdBody[2] := bf_UnChecked;
    IdBody[3] := bf_UnChecked;
    IdBody[4] := bf_UnChecked;
    IdBody[5] := bf_UnChecked;
    IdBody[6] := bf_UnChecked;
    IdBody[7] := bf_Checked;
    IdBody[8] := bf_UnChecked;

    Oblast[0] := bf_UnChecked;
    Oblast[1] := bf_UnChecked;
    Oblast[2] := bf_Checked;
    Oblast[3] := bf_UnChecked;
  end;

  LoadString(HInstance, 546, Retezec1, 50);
  Dlg := New(PTranMetDlg, Init(Application^.MainWindow, 'TransfRas', Retezec1, dg_TransformaceRastru));
  New(RB, InitResource(Dlg, id_RB2 ));
  New(RB, InitResource(Dlg, id_RB3 ));
  New(RB, InitResource(Dlg, id_RB4 ));
  New(RB, InitResource(Dlg, id_RB5 ));
  New(RB, InitResource(Dlg, id_RB6 ));
  New(RB, InitResource(Dlg, id_RB7 ));
  New(RB, InitResource(Dlg, id_RB8 ));
  New(RB, InitResource(Dlg, id_RB9 ));
  New(RB, InitResource(Dlg, id_RB10));
  New(RB, InitResource(Dlg, id_RB11));
  New(RB, InitResource(Dlg, id_RB12));
  New(RB, InitResource(Dlg, id_RB13));
  New(RB, InitResource(Dlg, id_RB14));
  Dlg^.TransferBuffer := @Data;
  if Application^.ExecDialog(Dlg) <> idCancel then
  begin
    NactiMetodu := true;
    with Data do
    begin
      i := 0;
      while IdBody[i] <> bf_Checked do
        inc(i);
      IdB := i;

      i := 0;
      while Oblast[i] <> bf_Checked do
        inc(i);
      Obl := i;
    end;
  end
  else
    NactiMetodu := false;
end;

var
  Transformace: pointer;

procedure TransformaceCeleho(
                             var Parametr); far;
var
  PomRohy: TObdelnik;

begin
  Transformace := pointer(Parametr);
  if Transformace <> nil then
  begin
  (*
    with PomRohy, SpravceRastru^.AktRastr^ do
    begin
      LD.X := IX;
      LD.Y := IY;
      PH.X := 1;
      PH.Y := 1;
    end;
    *)
    TransformaceNastavSourRohu(Transformace, PomRohy);
    Transformuj(Transformace, nil);
  end;
end;

procedure TransformaceIdBody(
                             var Parametr); far;
begin
  Transformace := pointer(Parametr);
  if Transformace <> nil then
    Transformuj(Transformace, nil);
end;

procedure TrObd(
                var Parametr); far;
var
  Rozmer: PObdelnik;
  PomRohy: TObdelnik;

begin
  Rozmer := PObdelnik(Parametr);
  (*
  with PomRohy, SpravceRastru^.AktRastr^ do
    case SourSystem of
      JTSK        : begin
                      PH.Y := (Rozmer^.PH.Y - MinY)/CY + 1;
                      PH.X := (Rozmer^.PH.X - MinX)/CX + 1;
                      LD.Y := (Rozmer^.LD.Y - MinY)/CY + 1;
                      LD.X := (Rozmer^.LD.X - MinX)/CX + 1;
                    end;
      Gauss       : begin
                      PH.Y := IY - (Rozmer^.PH.Y - MinY)/CY;
                      PH.X := IX - (Rozmer^.PH.X - MinX)/CX;
                      LD.Y := IY - (Rozmer^.LD.Y - MinY)/CY;
                      LD.X := IX - (Rozmer^.LD.X - MinX)/CX;
                    end;
      Matematicky : begin
                      PH.Y := IY - (Rozmer^.PH.X - MinX)/CY;
                      PH.X := IX - (Rozmer^.PH.Y - MinY)/CX;
                      LD.Y := IY - (Rozmer^.LD.X - MinX)/CY;
                      LD.X := IX - (Rozmer^.LD.Y - MinY)/CX;
                    end;
    end;
  TransformaceNastavSourRohu(Transformace, PomRohy);
  Dispose(Rozmer);
  Transformuj(Transformace, nil);
  *)
end;



procedure TrPol(
                var Parametr); far;
var
  Polygon, PomPtr: TLomBodPtr;
  PomRohy: TObdelnik;

begin
(*
  Polygon := TLomBodPtr(Parametr);
  if Polygon <> nil then
  begin
    with SpravceRastru^.AktRastr^ do
    begin
      PomPtr := Polygon;
      while PomPtr <> nil do
      begin
        PomPtr^.Sour.Y := IY - PomPtr^.Sour.Y;
        PomPtr         := PomPtr^.Dalsi
      end;

      with PomRohy do
      begin
        LD.Y:= -1E20; PH.Y:= 1E20; PH.X:= 1E20; LD.X:= -1E20;
      end;

      PomPtr := Polygon;
      while PomPtr <> nil do
      begin
        with PomPtr^.Sour, PomRohy do
        begin
          if (abs(Y) < 1E19) then
          begin
            if Y > LD.Y then LD.Y := Y;
            if Y < PH.Y then PH.Y := Y;
          end;

          if (abs(X) < 1E19) then
          begin
            if X > LD.X then LD.X := X;
            if X < PH.X then PH.X := X;
          end
        end;

        PomPtr:= PomPtr^.Dalsi
      end;
    end;

    TransformaceNastavSourRohu(Transformace, PomRohy);
    Transformuj(Transformace, Polygon);
  end;
  *)
end;




procedure TransformaceObdeln(
                             var Parametr); far;
var
  aProcedura: TProcedura;
  FlexObdelnik: PFlexVyberObd;
  RastrRozmer, OknoRozmer: TObdelnik;
  K1: double;
  Pom: TRect;
  Pom1, Pom2: TPoint;
  Retezec1: array[0..255] of char;
  OKej: boolean;

begin
(*
  Transformace := pointer(Parametr);
  if Transformace <> nil then
  begin
    SpravceRastru^.AktRastr^.DejRozmerRastru(RastrRozmer);

    with State^, PVyrezOkno(ZobrOkno)^ do
    begin
      GetClientRect(HWindow, Pom);
      with Pom do
      begin
        Pom1.X := left;
        Pom1.Y := bottom;
        Pom2.X := right;
        Pom2.Y := top;
      end;
      ObrBodNaSour(Pom1, OknoRozmer.LD);
      ObrBodNaSour(Pom2, OknoRozmer.PH);

      case SourSystem of
        JTSK       : K1 := (RozmerJTSK.LD.Y - RozmerJTSK.PH.Y)/VelikostBMP.X;
        Matematicky: K1 := (RozmerJTSK.PH.X - RozmerJTSK.LD.X)/VelikostBMP.X;
        Gauss      : K1 := (RozmerJTSK.PH.Y - RozmerJTSK.LD.Y)/VelikostBMP.X;
      end;

      case SourSystem of
        JTSK        : OKej := ((abs((OknoRozmer.LD.X  - OknoRozmer.PH.X) -
                                    (RastrRozmer.LD.X - RastrRozmer.PH.X)) < K1) and
                              (    (OknoRozmer.LD.Y  - OknoRozmer.PH.Y) -
                                   (RastrRozmer.LD.Y - RastrRozmer.PH.Y)  > K1))
                              or
                              ((abs((OknoRozmer.LD.Y  - OknoRozmer.PH.Y) -
                                    (RastrRozmer.LD.Y - RastrRozmer.PH.Y)) < K1) and
                              (    (OknoRozmer.LD.X  - OknoRozmer.PH.X) -
                                   (RastrRozmer.LD.X - RastrRozmer.PH.X)  > K1));
        Matematicky,
        Gauss       : OKej := ((abs((OknoRozmer.PH.X  - OknoRozmer.LD.X) -
                                    (RastrRozmer.PH.X - RastrRozmer.LD.X)) < K1) and
                              (    (OknoRozmer.PH.Y  - OknoRozmer.LD.Y) -
                                   (RastrRozmer.PH.Y - RastrRozmer.LD.Y)  > K1))
                              or
                              ((abs((OknoRozmer.PH.Y  - OknoRozmer.LD.Y) -
                                    (RastrRozmer.PH.Y - RastrRozmer.LD.Y)) < K1) and
                              (    (OknoRozmer.PH.X  - OknoRozmer.LD.X) -
                                   (RastrRozmer.PH.X - RastrRozmer.LD.X)  > K1));
      end;

      LoadString(HInstance, 114, Retezec1, 256);
      if not OKej and Souhlas(StrPas(Retezec1)) then
      begin
        NastavVyrez(RastrRozmer, false);
        Zobraz;
        PridejVyrezDoPameti;
      end;
    end;

    aProcedura   := TrObd;
    FlexObdelnik := New(PFlexVyberObd, Init(State, false, aProcedura, 10015));
    FlexObdelnik^.Select;
  end;
*)
end;


procedure TransformacePolygon(
                              var Parametr); far;
var
  aProcedura: TProcedura;
  VybPolygon: POrezLinie;

begin
  Transformace := pointer(Parametr);
  if Transformace <> nil then
  begin
    aProcedura := TrPol;
    VybPolygon := New(POrezLinie, Init(State, true, aProcedura, nil));
    VybPolygon^.Select;
  end;
end;




procedure VyberIdBoduZObrazovky(
                                Obl: word);
var
  IdBodyZObrazovky: PSnimacIdBodu;
  aProcedura: TProcedura;
  NovyRastr: boolean;
  JmTrTab: TPathStr;
  Cesta: TDirStr;
  Jmeno: TNameStr;
  Ext: TExtStr;
  NazevTransformaceIdB: TNazevTran;

begin
(*
  VolbaVsechObrazuProc(NovyRastr);
  if NovyRastr then
  begin
    FileSplit(SpravceRastru^.AktRastr^.Jmeno, Cesta, Jmeno, Ext);
    StrCopy(JmTrTab, Cesta);
    StrCat (JmTrTab, Jmeno);
    StrCat (JmTrTab, '.trt');
    case Obl of
      0: aProcedura := TransformaceCeleho;
      1: aProcedura := TransformaceIdBody;
      2: aProcedura := TransformaceObdeln;
      3: aProcedura := TransformacePolygon;
{$IFDEF PoCastech}
      4: aProcedura := TransformaceRastruPoCastechNepr;
{$ENDIF}
    end;

    LoadString(HInstance, 621, NazevTransformaceIdB, 20);

    IdBodyZObrazovky := New(PSnimacIdBodu, Init(State, true, aProcedura, 1, true, JmTrTab,
                                                nil, false, NazevTransformaceIdB, 10024));
    IdBodyZObrazovky^.Select;
  end;
*)
end;

procedure VyberIdBoduML(
                        Metoda, Obl: word);
var
  CilBodColl: PCilIdBodCollection;
  IdBodyZObrazovky: PSnimacIdBodu;
  aProcedura: TProcedura;
  NovyRastr: boolean;
  JmTrTab: TPathStr;
  Cesta: TDirStr;
  Jmeno: TNameStr;
  Ext: TExtStr;
  NazevTransformaceIdB: TNazevTran;

begin
(*
  VolbaVsechObrazuProc(NovyRastr);
  if NovyRastr and VratParametryML(Metoda, CilBodColl) then
  begin
    FileSplit(SpravceRastru^.AktRastr^.Jmeno, Cesta, Jmeno, Ext);
    StrCopy(JmTrTab, Cesta);
    StrCat (JmTrTab, Jmeno);
    StrCat (JmTrTab, '.trt');
    case Obl of
      0: aProcedura := TransformaceCeleho;
      1: aProcedura := TransformaceIdBody;
      2: aProcedura := TransformaceObdeln;
      3: aProcedura := TransformacePolygon;
{$IFDEF PoCastech}
      4: aProcedura := TransformaceRastruPoCastechNepr;
{$ENDIF}
    end;

    LoadString(HInstance, 621, NazevTransformaceIdB, 20);

    IdBodyZObrazovky := New(PSnimacIdBodu, Init(State, true, aProcedura, 1, true, JmTrTab,
                                                CilBodColl, true, NazevTransformaceIdB, 10024));
    IdBodyZObrazovky^.Select;
  end;
  *)
end;



procedure VyberIdBoduObdelnik(
                              Obl: word);
var
  CilBodColl: PCilIdBodCollection;
  IdBodyZObrazovky: PSnimacIdBodu;
  aProcedura: TProcedura;
  NovyRastr: boolean;
  JmTrTab: TPathStr;
  Cesta: TDirStr;
  Jmeno: TNameStr;
  Ext: TExtStr;
  NazevTransformaceIdB: TNazevTran;

begin
(*
  VolbaVsechObrazuProc(NovyRastr);
  if NovyRastr and VratParametryObdelniku(CilBodColl) then
  begin
    FileSplit(SpravceRastru^.AktRastr^.Jmeno, Cesta, Jmeno, Ext);
    StrCopy(JmTrTab, Cesta);
    StrCat (JmTrTab, Jmeno);
    StrCat (JmTrTab, '.trt');
    case Obl of
      0: aProcedura := TransformaceCeleho;
      1: aProcedura := TransformaceIdBody;
      2: aProcedura := TransformaceObdeln;
      3: aProcedura := TransformacePolygon;
{$IFDEF PoCastech}
      4: aProcedura := TransformaceRastruPoCastechNepr;
{$ENDIF}
    end;

    LoadString(HInstance, 621, NazevTransformaceIdB, 20);

    IdBodyZObrazovky := New(PSnimacIdBodu, Init(State, true, aProcedura, 1, true, JmTrTab,
                                                CilBodColl, true, NazevTransformaceIdB, 10024));
    IdBodyZObrazovky^.Select;
  end;
  *)
end;


procedure NacteniTransfTabulky(
                               Obl: word);
var
  CilBodColl: PCilIdBodCollection;
  IdBodyZObrazovky: PSnimacIdBodu;
  aProcedura: TProcedura;
  NovyRastr: boolean;
  JmTrTab: TPathStr;
  NazevTransformaceIdB: TNazevTran;
  i, PomCislo: longInt;

begin
(*
  VolbaVsechObrazuProc(NovyRastr);
  if NovyRastr and NactiTransfTabulku(CilBodColl, JmTrTab, NazevTransformaceIdB) then
  begin
    case Obl of
      0: aProcedura := TransformaceCeleho;
      1: aProcedura := TransformaceIdBody;
      2: aProcedura := TransformaceObdeln;
      3: aProcedura := TransformacePolygon;
{$IFDEF PoCastech}
      4: aProcedura := TransformaceRastruPoCastechNepr;
{$ENDIF}
    end;

    PomCislo := 0;
    for i := 0 to pred(CilBodColl^.Count) do
      if PCilIdBod(CilBodColl^.At(i))^.cCislo > PomCislo then
        PomCislo := PCilIdBod(CilBodColl^.At(i))^.cCislo;
    IdBodyZObrazovky := New(PSnimacIdBodu, Init(State, true, aProcedura, PomCislo+1,
                                                true, JmTrTab, CilBodColl, false, NazevTransformaceIdB, 10024));
    IdBodyZObrazovky^.Select;
  end;
*)
end;


procedure NacteniIdBZDB(
                        Obl: word);
var
  CilBodColl: PCilIdBodCollection;
  IdBodyZObrazovky: PSnimacIdBodu;
  aProcedura: TProcedura;
  NovyRastr: boolean;
  JmTrTab: TPathStr;
  NazevTransformaceIdB: TNazevTran;

begin
(*
  VolbaVsechObrazuProc(NovyRastr);
  if NovyRastr and NactiIdBZDB(CilBodColl, JmTrTab) then
  begin
    case Obl of
      0: aProcedura := TransformaceCeleho;
      1: aProcedura := TransformaceIdBody;
      2: aProcedura := TransformaceObdeln;
      3: aProcedura := TransformacePolygon;
{$IFDEF PoCastech}
      4: aProcedura := TransformaceRastruPoCastechNepr;
{$ENDIF}
    end;

    LoadString(HInstance, 621, NazevTransformaceIdB, 20);

    IdBodyZObrazovky := New(PSnimacIdBodu, Init(State, true, aProcedura, 1, true, JmTrTab,
                                                CilBodColl, false, NazevTransformaceIdB, 10024));
    IdBodyZObrazovky^.Select;
  end;
*)
end;


procedure UrciTrKlicATransformuj(
                                 IdB, Obl: word);
begin
  case IdB of
    0   : NacteniIdBZDB(Obl);
    1..5: VyberIdBoduML(IdB, Obl);
    6   : VyberIdBoduObdelnik(Obl);
    7   : VyberIdBoduZObrazovky(Obl);
    8   : NacteniTransfTabulky(Obl);
  end;
end;
{$IFDEF PoCastech}
procedure UrciTrKlicATransformujPoCastech(
                                          IdB: word);
begin
  case IdB of
    0   : NacteniIdBZDB(4);
    1..5: VyberIdBoduML(IdB, 4);
    6   : VyberIdBoduObdelnik(4);
    7   : VyberIdBoduZObrazovky(4);
    8   : NacteniTransfTabulky(4);
  end;
end;

function NactiMetoduTrPoCastech(
                                var IdB : word): boolean;

type
  TMetodaTrData = record
    IdBody: array[0..8] of word;
  end;

var
  Data: TMetodaTrData;
  Dlg: PTranMetDlg;
  RB: PRadioButton;
  i: word;
  Retezec1: array[0..50] of char;

begin
  with Data do
  begin
    IdBody[0] := bf_UnChecked;
    IdBody[1] := bf_UnChecked;
    IdBody[2] := bf_UnChecked;
    IdBody[3] := bf_UnChecked;
    IdBody[4] := bf_UnChecked;
    IdBody[5] := bf_UnChecked;
    IdBody[6] := bf_UnChecked;
    IdBody[7] := bf_Checked;
    IdBody[8] := bf_UnChecked;
  end;

  LoadString(HInstance, 441, Retezec1, 50);
  Dlg := New(PTranMetDlg, Init(Application^.MainWindow, 'TransfVek', Retezec1, dg_TransformaceRastruPC));
  New(RB, InitResource(Dlg, id_RB2 ));
  New(RB, InitResource(Dlg, id_RB3 ));
  New(RB, InitResource(Dlg, id_RB4 ));
  New(RB, InitResource(Dlg, id_RB5 ));
  New(RB, InitResource(Dlg, id_RB6 ));
  New(RB, InitResource(Dlg, id_RB7 ));
  New(RB, InitResource(Dlg, id_RB8 ));
  New(RB, InitResource(Dlg, id_RB9 ));
  New(RB, InitResource(Dlg, id_RB10));
  Dlg^.TransferBuffer := @Data;
  if Application^.ExecDialog(Dlg) <> idCancel then
  begin
    NactiMetoduTrPoCastech := true;
    with Data do
    begin
      i := 0;
      while IdBody[i] <> bf_Checked do
        inc(i);
      IdB := i;
    end;
  end
  else
    NactiMetoduTrPoCastech := false;
end;
{$ENDIF}

end.
